function Live_phrase()

 local vb = renoise.ViewBuilder()
 
 
 local perilla_db = {}
 local perilla_activa = true
 
 local keys = {"c", "c#", "d", "d#", "e", "f", "f#", "g", "g#", "a", "a#", "b"}
 
 ---create major scales.
 
 local scale = {}
 
 scale[1] = {} --- creating c major scale.
 for octave = 0, 9 do
   table.insert(scale[1], 0 + octave * 12)
   table.insert(scale[1], 2 + octave * 12)
   table.insert(scale[1], 4 + octave * 12)
   table.insert(scale[1], 5 + octave * 12)
   table.insert(scale[1], 7 + octave * 12)
   table.insert(scale[1], 9 + octave * 12)
   table.insert(scale[1], 11 + octave * 12)
 end
 
 for i = 2, 12 do ----creating the other scales from the c major scale.
 
 scale[i] = {}
 
   for n = 1, #scale[1] do
   
     table.insert(scale[i], scale[1][n] + i - 1 )  
   
   end
   
 end  
 
 -- Create a function that counts the number of phrases for the biggest track.

 local function BiggestTrackPhrases()
    local NumberOfPhrasesForThisTrack = 0
    for InstrumentIndex = 1, #renoise.song().instruments do
      if #renoise.song():instrument(InstrumentIndex).phrases > NumberOfPhrasesForThisTrack then NumberOfPhrasesForThisTrack = #renoise.song():instrument(InstrumentIndex).phrases
      end
    end
    return NumberOfPhrasesForThisTrack
 end  
 
 local function Pitch_corrector(instrument, phrase)
 
    
 
     local a = renoise.song():instrument(instrument):phrase(phrase)
   
     local value = vb.views["major_scale_popup"].value
   
     for linea = 1, a.number_of_lines do
   
       for columna = 1, renoise.InstrumentPhrase.MAX_NUMBER_OF_NOTE_COLUMNS do
       
         local is_in_scale = false
     
         for i = 1, #scale[value] do        
     
           if a:line(linea):note_column(columna).note_value == scale[value][i] then 
             break
           elseif i == #scale[value] and a:line(linea):note_column(columna).note_value ~= scale[value][i] then 
           
             local note = a:line(linea):note_column(columna).note_value
             while true do
               local aumento  
               
               if vb.views["up_or_down_popup_scale"].value == 1 then aumento = 1
               elseif vb.views["up_or_down_popup_scale"].value == 2 then aumento = -1
               end
                
               note = note + aumento
               local is_in_scale = false
             
               if note > 119 or note < 0 then
                 a:line(linea):note_column(columna).note_value = 121 
                 break 
               elseif note > -1 and note < 120 then
                 for n = 1, #scale[value] do
                   if note == scale[value][n] then 
                     a:line(linea):note_column(columna).note_value = note
                     is_in_scale = true
                     break
                   end
                 end 
                 if is_in_scale == true then break end 
               end 
               
             end  
             
             if is_in_scale == true then break end     
                           
             
           end
         
         end
       
       end
     
     end 
     
             
    
     
   
 end
     
 
 
 ---------------
 
 local function transpose_phrase(amount_transposed, instrument, phrase)
 
   local a = renoise.song():instrument(instrument):phrase(phrase) 
 
   for linea = 1, a.number_of_lines do
     for columna = 1, renoise.InstrumentPhrase.MAX_NUMBER_OF_NOTE_COLUMNS do
     
       if a:line(linea):note_column(columna).note_value ~= 120 and a:line(linea):note_column(columna).note_value ~= 121 then
       
         local new_note_value = a:line(linea):note_column(columna).note_value + amount_transposed
         
         if new_note_value < 0 then new_note_value = 119 
         elseif new_note_value > 119 then new_note_value = 0 
         end   
     
         a:line(linea):note_column(columna).note_value = new_note_value
         
       end  
       
     end
     
   end       
 
 end
 
 local function chord_creation(phrase, s_line, s_column, note_one, note_two)
   
   phrase:line(s_line):note_column(s_column + 1).note_value = phrase:line(s_line):note_column(s_column).note_value + note_one
   phrase:line(s_line):note_column(s_column + 1).volume_value = phrase:line(s_line):note_column(s_column).volume_value
   phrase:line(s_line):note_column(s_column + 1).instrument_value = phrase:line(s_line):note_column(s_column).instrument_value
                          
   phrase:line(s_line):note_column(s_column + 2).note_value = phrase:line(s_line):note_column(s_column).note_value + note_two
   phrase:line(s_line):note_column(s_column + 2).volume_value = phrase:line(s_line):note_column(s_column).volume_value
   phrase:line(s_line):note_column(s_column + 2).instrument_value = phrase:line(s_line):note_column(s_column).instrument_value
   
 end            
   
 
 ----------create the column to make major and minor chords.
 local chords_column = vb:column{}
 local chords_single_row = {}
 
 for ro = 1, 3 do ---ro means row.
 
   chords_single_row[ro] = vb:row{}
   for bu = 1, 3 do ---bu means button.
   
     chords_single_row[ro]:add_child(
      
       vb:button{ 
         id = "chord_bottom"..tostring(ro)..tostring(bu),
         notifier = function()
         
           local s_line = renoise.song().selection_in_phrase.start_line 
           local s_column = renoise.song().selection_in_phrase.start_column
           local phrase = renoise.song():instrument(renoise.song().selected_instrument_index):phrase(renoise.song().selected_phrase_index)
           
           if ro == 1 and bu == 1 then  
           
             chord_creation(phrase, s_line, s_column, 4, 7)
             
           elseif ro == 1 and bu == 2 then
           
             chord_creation(phrase, s_line, s_column, 4, 7-12) 
             
           elseif ro == 1 and bu == 3 then
           
             chord_creation(phrase, s_line, s_column, 4-12, 7-12)
             
           elseif ro == 2 and bu == 1 then 
           
             chord_creation(phrase, s_line, s_column, -4, 3)
             
           elseif ro == 2 and bu == 2 then
           
             chord_creation(phrase, s_line, s_column, 12-4, 3) 
             
           elseif ro == 2 and bu == 3  then 
           
             chord_creation(phrase, s_line, s_column, -4, 3-12) 
             
           elseif ro == 3 and bu == 1 then 
           
             chord_creation(phrase, s_line, s_column, -3, -7) 
             
           elseif ro == 3 and bu == 2 then
           
             chord_creation(phrase, s_line, s_column, -3, 12-7)
             
           elseif ro == 3 and bu == 3 then 
           
             chord_creation(phrase, s_line, s_column, 12-3, 12-7 )               
             
           end   
         
         
         end
       }
       
     )
     
   end
   
   chords_column:add_child(chords_single_row[ro])
   
 end     
 
 
 local minor_chords_column = vb:column{}
 local minor_chords_single_row = {}
 
 for ro = 1, 3 do ---ro means row.
 
   minor_chords_single_row[ro] = vb:row{}
   for bu = 1, 3 do ---bu means button.
   
     minor_chords_single_row[ro]:add_child(
      
       vb:button{ 
         id = "minor_chord_bottom"..tostring(ro)..tostring(bu),
         notifier = function()
         
           local s_line = renoise.song().selection_in_phrase.start_line 
           local s_column = renoise.song().selection_in_phrase.start_column
           local phrase = renoise.song():instrument(renoise.song().selected_instrument_index):phrase(renoise.song().selected_phrase_index)
           
           if ro == 1 and bu == 1 then  
           
             chord_creation(phrase, s_line, s_column, 3, 7)
             
           elseif ro == 1 and bu == 2 then
           
             chord_creation(phrase, s_line, s_column, 3, 7-12) 
             
           elseif ro == 1 and bu == 3 then
           
             chord_creation(phrase, s_line, s_column, 3-12, 7-12)
             
           elseif ro == 2 and bu == 1 then 
           
             chord_creation(phrase, s_line, s_column, -3, 4)
             
           elseif ro == 2 and bu == 2 then
           
             chord_creation(phrase, s_line, s_column, 12-3, 4) 
             
           elseif ro == 2 and bu == 3  then 
           
             chord_creation(phrase, s_line, s_column, -3, 4-12) 
             
           elseif ro == 3 and bu == 1 then 
           
             chord_creation(phrase, s_line, s_column, -4, -7) 
             
           elseif ro == 3 and bu == 2 then
           
             chord_creation(phrase, s_line, s_column, -4, 12-7)
             
           elseif ro == 3 and bu == 3 then 
           
             chord_creation(phrase, s_line, s_column, 12-4, 12-7 )               
             
           end   
         
         
         end         
       }
       
     )
     
   end
   
   minor_chords_column:add_child(minor_chords_single_row[ro])
   
 end 
 
 
    
 vb:row{
    
   id = "row where chord buttons are contained",
    
   visible = false,
    
   vb:text{text = "major chords"},
    
   chords_column,
    
   vb:space{ width = 8 },
    
   vb:text{text = "minor chords"},
    
   minor_chords_column 
 }
       
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 ----------------------------------------------------------
 
 while #renoise.song().patterns < 100 do
   renoise.song().sequencer:insert_new_pattern_at(#renoise.song().patterns+1)
 end  
 
 for i = 1, #renoise.song().patterns do
 
   renoise.song().patterns[i].number_of_lines = renoise.Pattern.MAX_NUMBER_OF_LINES
 
 end
 
 local last_phrase_copied = nil
 
 local current_number_of_instruments = #renoise.song().instruments ---this is for the observable when we add or delete a track.
 
 local add_track_is_pushed = false
 
 local delete_track_is_pushed = false
  
 local phrases_playing_array = {}
 
 local Superior_Column_dictionary = {} 
 
 local Page_among_tracks_text = vb:text{
   text = "1"
 }
 
 
 local Page_among_phrases_text = vb:text{
   text = "1",
   id = "Page_among_phrases_text"
 }
 
 ---lets create a function that puts the instrument in keymap mode and

 local function instruments_phrases_setup(instrument, phrase)
 
   ---renoise.song().instruments[instrument].phrases[phrase].mapping.key_tracking = 1
   
   if renoise.song().transport.follow_player == false then renoise.song().transport.follow_player = true end
   
   local b = renoise.song():instrument(instrument)
   
   b.phrase_playback_mode = 1 
  
   b.phrase_program = 0  
   
   b:phrase(phrase).key_tracking = 1
      
   ---renoise.song().instruments[instrument].phrases[phrase].mapping.note_range = {phrase-1, phrase-1}
   
 
 
 end  
 
 ---lets create a function that writes the phrase into the edit pattern when the plays button is pushed.
 local master_is_pushed = {}
 local is_pushed = {}---if the phrase is pushed.
 local legato_is_pushed = {}
 local instrument_playback_position_start = {}
 local last_master_play_button_playing
 local there_are_phrases_playing_in_this_track = {} 
 local sequence_of_phrases_played_in_this_track = {}
 
 local function linea_donde_cae(last_sequence, last_line, current_sequence, current_line)
   local distance = 0
   if last_sequence == current_sequence then
     distance = current_line - last_line + 1
   else
       
     for pattern = last_sequence, current_sequence do ---count the distance since the last position to the new position.
       
       if pattern == last_sequence then
         distance = distance + (renoise.song():pattern(pattern).number_of_lines - last_line) + 1 
           
       elseif pattern == current_sequence then
         
         distance = distance + (current_line)
          
       else distance = distance + renoise.song():pattern(pattern).number_of_lines
         
       end
         
     end 
         
   end 
   
   return distance
 end  
 
 local function phrase_last_playback_position_per_track(instrument, list, secuencia, linea)
    
 
       local current_sequence = renoise.song().transport.edit_pos.sequence
       local current_line = renoise.song().transport.edit_pos.line
       
       if secuencia ~= 0 then current_sequence = secuencia end ---this will be used to implement in the fill.
       if linea ~= 0 then current_line = linea end  
       
       
        
       local linea_donde_comienza = 1
       local lineas_avanzadas = 0
       for p = 1, #list do
         if p == #list then
         
           lineas_avanzadas = linea_donde_cae(list[p][3], list[p][4], current_sequence, current_line) - 1
           
           for i = 1, lineas_avanzadas do
             linea_donde_comienza = linea_donde_comienza + 1
             if linea_donde_comienza > list[p][2] then
               linea_donde_comienza = 1
             end
           end
         
         else
       
           lineas_avanzadas = linea_donde_cae(list[p][3], list[p][4], list[p+1][3], list[p+1][4]) - 1
           
           for i = 1, lineas_avanzadas do
             linea_donde_comienza = linea_donde_comienza + 1
             if linea_donde_comienza > list[p][2] then
               linea_donde_comienza = 1
             end
           end
            
           
         end       
             
           
             
           
           
       end  
       
       return linea_donde_comienza  
           
       
 
 end
 
 local function write_phrase_into_pattern(instrument, phrase)
        
 
   ---local effect_amount_value = phrase_last_playback_position_per_track(instrument, phrase) 
  
   
   instruments_phrases_setup(instrument, phrase)
   
   
   ----set the quantization:
   local list = sequence_of_phrases_played_in_this_track[instrument]
   local quantization = 0
   local frase_lines = renoise.song():instrument(instrument):phrase(phrase).number_of_lines 
   local linea_donde_comienza_esta_frase 
   local verdadera_linea_donde_comienza_esta_frase = 0
   local current_sequence = renoise.song().transport.edit_pos.sequence
   local current_line = renoise.song().transport.edit_pos.line
   
   
   
   local quantization_setup 
   if vb.views["quantization_setup_phrase"..tostring(instrument)..tostring(phrase)].value == 1 then
     if vb.views["global_quantization"].value == 1 then
       quantization_setup = 1
     else 
       quantization_setup = 2
     end
   elseif vb.views["quantization_setup_phrase"..tostring(instrument)..tostring(phrase)].value == 2 then
     quantization_setup = 1
   else 
     quantization_setup = 2
   end  
   
   
   if renoise.song().transport.playing == true then 
     current_line = current_line + 1
     if current_line > renoise.song():pattern(current_sequence).number_of_lines then
       if current_line > renoise.song():pattern(current_sequence).number_of_lines then
         current_line = 1
         current_sequence = current_sequence + 1
         if current_sequence > #renoise.song().patterns then
           current_sequence = 1
         end
         
       end
     end
   end  
           
   
   
   if list ~= nil and quantization_setup == 1 then ---this means that quantization is set to "Phrase".
     linea_donde_comienza_esta_frase = phrase_last_playback_position_per_track(instrument, list, 0, 0)        
   
     quantization = list[#list][2] + 1 - linea_donde_comienza_esta_frase
       
     current_line = renoise.song().transport.edit_pos.line + quantization
   
     if current_line > renoise.song():pattern(current_sequence).number_of_lines then
       current_line = current_line - quantization
     
       for i = 1, quantization do
         current_line = current_line + 1
         if current_line > renoise.song():pattern(current_sequence).number_of_lines then
           current_line = 1
           current_sequence = current_sequence + 1
           if current_sequence > #renoise.song().patterns then
             current_sequence = 1
           end
         
         end
       end 
     end 
     
   end   
   
       
   
   --or ((there_are_phrases_playing_in_this_track[instrument] == false or there_are_phrases_playing_in_this_track[instrument] == nil)) placed after the 2 above
   --renoise.song().transport.playing == true <------ this was placed above instead of the second true.
 
           
   if renoise.song():track(instrument).visible_effect_columns < 3 then 
     renoise.song():track(instrument).visible_effect_columns = 3 
   end  
  
             
     
   
   ---scenario 1: play button is not previously pushed, thus we need to activate it.
   
   if is_pushed[tostring(instrument)..tostring(phrase)] == nil or is_pushed[tostring(instrument)..tostring(phrase)] == false then     
     is_pushed[tostring(instrument)..tostring(phrase)] = true
     vb.views["start_playing_button"].color = {0xb7, 0xd5, 0xac}
     if last_master_play_button_playing == nil then---this is code for the master button:
       last_master_play_button_playing = phrase
       vb.views["Play Button from master"..tostring(phrase)].color = {0x00, 0x00, 0xb3}
     end  
     
   
     vb.views["play_button_"..tostring(instrument)..tostring(phrase)].color = {0xa5, 0xd6, 0x10}
     
     for i = 1, #renoise.song():instrument(instrument).phrases do ---if there is other phrase playing from the same track then stop that phrase.
       if is_pushed[tostring(instrument)..tostring(i)] == true and i ~= phrase then 
         is_pushed[tostring(instrument)..tostring(i)] = false
         vb.views["play_button_"..tostring(instrument)..tostring(i)].color = {0,0,0} 
         break
       end
     end 
     
            
       
                      
    
     
     
        
       local a = renoise.song():pattern(current_sequence):track(instrument):line(current_line) 
       local legato = "legato_mode"..tostring(instrument)..tostring(phrase)
       
       local b = a:note_column(1)
       b.note_value = 48
       
       local c = a:effect_column(2)
       c.number_string = "0Z"    
       c.amount_value = phrase
       
       
       if (legato_is_pushed[legato] == true or legato_is_pushed[legato] == nil) and list ~= nil and quantization_setup == 2 then --si legato está activado y no es la primera frase de este track:
       
       
        --[[ local d = a:effect_column(3)    
         d.number_string = "0S"   
         local linea_donde_quedo_la_ultima_frase = phrase_last_playback_position_per_track(instrument, list, 0, 0)
         local linea = 0
         if linea_donde_quedo_la_ultima_frase > frase_lines then
           
           for i = 1, linea_donde_quedo_la_ultima_frase do
           
             linea = linea + 1
             if linea > frase_lines then 
               linea = 1
             end  
           
           end
           linea_donde_quedo_la_ultima_frase = linea 
         
         end     
         linea_donde_quedo_la_ultima_frase = linea_donde_quedo_la_ultima_frase + 1
         if linea_donde_quedo_la_ultima_frase > frase_lines then 
           linea_donde_quedo_la_ultima_frase = 1
         end  
         d.amount_value = linea_donde_quedo_la_ultima_frase--]]
       else
         b.instrument_value = instrument-1 
       
       end 
       
       
       

       
       
       ---next code is to implement the quantization:
       
       
       if there_are_phrases_playing_in_this_track[instrument] == false or there_are_phrases_playing_in_this_track[instrument] == nil or legato_is_pushed[legato] == false or sequence_of_phrases_played_in_this_track[instrument] == nil then 
              
         sequence_of_phrases_played_in_this_track[instrument] = {{phrase, frase_lines, current_sequence, current_line }} 
         
       elseif there_are_phrases_playing_in_this_track[instrument] == true and (legato_is_pushed[legato] == true or legato_is_pushed[legato] == nil) then
         
         
         table.insert(sequence_of_phrases_played_in_this_track[instrument], {phrase, frase_lines, current_sequence, current_line } )  
         
       end   
       
       there_are_phrases_playing_in_this_track[instrument] = true 
       
       
       
       ---quantization code ends here. :)  
     
       if renoise.song().transport.playing == false then
         for ins = 1, #renoise.song().instruments do
         
           if there_are_phrases_playing_in_this_track[ins] == true then
             for phr = 1, #renoise.song().instruments[ins].phrases do 
           
               if ins == instrument then 
                 break
               end  
 
               if is_pushed[tostring(ins)..tostring(phr)] == true then
                 local e = renoise.song():pattern(current_sequence):track(ins):line(current_line)
                 e:note_column(1).note_value = 48
                
                 e:effect_column(2).number_string = "0Z" 
                 e:effect_column(2).amount_value = phr
                 break
               end
             
             end
           end
         end  
       
         renoise.song().transport:start_at(renoise.SongPos(current_sequence, current_line))
       
       end 
       
       ---el siguiente código es para implementar el modo fill:
       
       local numero_de_frases_que_faltan = #renoise.song():instrument(instrument).phrases - phrase
       
       if vb.views["Number_Of_Phrase"..tostring(instrument)..tostring(phrase)].text == "fill" then
               
         for frase = 0, numero_de_frases_que_faltan do
         
           if vb.views["Number_Of_Phrase"..tostring(instrument)..tostring(phrase + frase)].text == "fill" then
       
             local linea_de_phrase_donde_empieza = phrase_last_playback_position_per_track(instrument, sequence_of_phrases_played_in_this_track[instrument], current_sequence, current_line) 
             local lineas_que_faltan_para_que_empiece_la_siguiente_frase = frase_lines - linea_de_phrase_donde_empieza + 1
         
             current_line = current_line + lineas_que_faltan_para_que_empiece_la_siguiente_frase 
         
             if current_line > renoise.song():pattern(current_sequence).number_of_lines then
               current_line = current_line - lineas_que_faltan_para_que_empiece_la_siguiente_frase
     
               for i = 1, lineas_que_faltan_para_que_empiece_la_siguiente_frase do
                 current_line = current_line + 1
                 if current_line > renoise.song():pattern(current_sequence).number_of_lines then
                   current_line = 1
                   current_sequence = current_sequence + 1
                   if current_sequence > #renoise.song().patterns then
                     current_sequence = 1
                   end
         
                 end
               end 
             end 
         
             ---ahora tenemos que preguntarnos si hay una frase siguiente, si no hay simplemente ponemos un note-off para apagar la frase:
         
             if #renoise.song():instrument(instrument).phrases == phrase + frase then
         
               local a = renoise.song():pattern(current_sequence):track(instrument):line(current_line) 
       
               a:note_column(1).note_value = 120
              
       
               a:effect_column(2).number_string = "0Z"    
       
               a:effect_column(2).amount_value = phrase + frase
       
               a:note_column(1).instrument_value = instrument-1
           
               is_pushed[tostring(instrument)..tostring(phrase + frase)] = false
               there_are_phrases_playing_in_this_track[instrument] = false
               sequence_of_phrases_played_in_this_track[instrument] = nil
     
   
               vb.views["play_button_"..tostring(instrument)..tostring(phrase + frase)].color = {0,0,0}           
           
             else 
           
               vb.views["play_button_"..tostring(instrument)..tostring(phrase + frase)].color = {0,0,0}
           
               vb.views["play_button_"..tostring(instrument)..tostring(phrase + 1 + frase)].color = {0xa5, 0xd6, 0x10}
           
               local a = renoise.song():pattern(current_sequence):track(instrument):line(current_line) 
         
               a:note_column(1).note_value = 48
              
       
               a:effect_column(2).number_string = "0Z"    
       
               a:effect_column(2).amount_value = phrase + 1 + frase
       
               a:note_column(1).instrument_value = instrument-1 
           
               is_pushed[tostring(instrument)..tostring(phrase + frase)] = false
               is_pushed[tostring(instrument)..tostring(phrase + 1 + frase)] = true
               sequence_of_phrases_played_in_this_track[instrument] = {{phrase + 1 + frase, renoise.song():instrument(instrument):phrase(phrase + 1).number_of_lines, current_sequence, current_line }} 
           
             end 
                           
           end  
           
         end     
       
       end              
      
   
   ---scenario 2: play button has been previously pushed, hence we need to input an off to stop the playing.
   
   elseif is_pushed[tostring(instrument)..tostring(phrase)] == true then
     is_pushed[tostring(instrument)..tostring(phrase)] = false
     there_are_phrases_playing_in_this_track[instrument] = false
     sequence_of_phrases_played_in_this_track[instrument] = nil
     
   
     vb.views["play_button_"..tostring(instrument)..tostring(phrase)].color = {0,0,0}
       
       local line = renoise.song():pattern(current_sequence):track(instrument):line(current_line):note_column(1) 
       
       if renoise.song().transport.playing == true then 
     
         line.note_value = 120 
       
         line.instrument_value = instrument-1 
         
       end   
               
     
   end 
   
    
  end           
 
 -----create the function for the master's play buttons.
 
  local function play_button_for_master(phrase)
 
    if last_master_play_button_playing ~= nil and phrase ~= last_master_play_button_playing then ---if the current play button pushed is not the same as the last pushed, then:
    
      vb.views["Play Button from master"..tostring(last_master_play_button_playing)].color = {0, 0, 0} ---change the color  
      master_is_pushed[tostring(last_master_play_button_playing)] = false ----swich it to false.
    
    end
    
    for instrument = 1, #renoise.song().instruments do
      if vb.views["play_button_"..tostring(instrument)..tostring(phrase)] == nil then ---if the phrase in this row exists then play it:
        if is_pushed[tostring(instrument)..tostring(last_master_play_button_playing)] == true then 
          write_phrase_into_pattern(instrument, last_master_play_button_playing)
        end     
      
      else  
        write_phrase_into_pattern(instrument, phrase)
      end  
    end
    
    if master_is_pushed[tostring(phrase)] == nil or master_is_pushed[tostring(phrase)] == false then ---if its not pushed then change the color    
      master_is_pushed[tostring(phrase)] = true   ---and switch this to true.
      
      vb.views["Play Button from master"..tostring(phrase)].color = {0x00, 0x00, 0xb3} 
     
    end
    
    last_master_play_button_playing = phrase---record this play button as the last pushed.
    
    
    
      
      
  
  end
  
 
 ---Create the variables that will establish the number of phrases and tracks per page the All_Tracks_Column will have

local Number_of_phrases_per_page = 8
local Number_of_tracks_per_page = 8
 
 --- Create a function that makes a list with the limit values for phrases that each page has.

  local function Limit_values_For_Phrases(InstrumentIndex)
    local Limit_Values_Array = {}
    local constant = Number_of_phrases_per_page - 1
    local Number_Of_Pages_For_This_Track = #renoise.song():instrument(InstrumentIndex).phrases - constant
    if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
    
    
    for page = 1, Number_Of_Pages_For_This_Track do
    
      table.insert(Limit_Values_Array, {page, Number_of_phrases_per_page + page - 1})
      
      while page == 1 do 
        if #renoise.song():instrument(InstrumentIndex).phrases < Number_of_phrases_per_page then 
          Limit_Values_Array[1][2] = #renoise.song():instrument(InstrumentIndex).phrases
        end
        break
      end
      
    end
    
    local Number_Of_Extra_Pages_After_Last_Page 
    if Number_Of_Pages_For_This_Track == 1 then Number_Of_Extra_Pages_After_Last_Page = #renoise.song():instrument(InstrumentIndex).phrases - 1
    else Number_Of_Extra_Pages_After_Last_Page = Number_of_phrases_per_page - 1
    end      
    
    for page = 1, Number_Of_Extra_Pages_After_Last_Page do
      table.insert(Limit_Values_Array, {Number_Of_Pages_For_This_Track+page, #renoise.song():instrument(InstrumentIndex).phrases})
    end
   
    if #renoise.song():instrument(InstrumentIndex).phrases == 0 then return nil 
    else return Limit_Values_Array 
    end
    
  end       
    
--- Create a function that makes a list with the limit values for tracks that each page has.            

  local function Limit_values_For_Tracks()
    local Limit_Values_Array = {}
    local constant = Number_of_tracks_per_page - 1
    local Number_Of_Pages_For_Tracks = #renoise.song().instruments - constant
    if Number_Of_Pages_For_Tracks <= 0 then Number_Of_Pages_For_Tracks = 1 end
    
    for page = 1, Number_Of_Pages_For_Tracks do
    
      table.insert(Limit_Values_Array, {page, Number_of_tracks_per_page + page - 1})
      
      while page == 1 do
        if #renoise.song().instruments < Number_of_tracks_per_page then
          Limit_Values_Array[1][2] = #renoise.song().instruments
        end
        break
      end
      
    end
    
    return Limit_Values_Array
     
  end            
    
---Create a function that express the limits for master columns for each page.

 local function limit_values_for_master()
   local Limit_Values_Array = {}
    local constant = Number_of_phrases_per_page - 1
    local Number_Of_Pages_For_Master = BiggestTrackPhrases() - constant
    if Number_Of_Pages_For_Master <= 0 then Number_Of_Pages_For_Master = 1 end
    
    for page = 1, Number_Of_Pages_For_Master do
    
      table.insert(Limit_Values_Array, {page, Number_of_phrases_per_page + page - 1})
      
      while page == 1 do 
        if BiggestTrackPhrases() < Number_of_phrases_per_page then 
          Limit_Values_Array[1][2] = BiggestTrackPhrases()
        end
        break
      end
      
    end
    
    local Number_Of_Extra_Pages_After_Last_Page 
    if Number_Of_Pages_For_Master == 1 then Number_Of_Extra_Pages_After_Last_Page = BiggestTrackPhrases() - 1
    else Number_Of_Extra_Pages_After_Last_Page = Number_of_phrases_per_page - 1
    end      
    
    for page = 1, Number_Of_Extra_Pages_After_Last_Page do
      table.insert(Limit_Values_Array, {Number_Of_Pages_For_Master+page, BiggestTrackPhrases()})
    end
    
    return Limit_Values_Array 
 end    
 
 
 
 
 -------create rotary function
 
 local function create_rotary_column(InstrumentIndex)


  perilla_db["perilla_name_textfield"..InstrumentIndex.."1"] = "volume"
  perilla_db["perilla_effect_textfield"..InstrumentIndex.."1"] = "0L"
  perilla_db["perilla"..InstrumentIndex.."1"] = 192
  
  perilla_db["perilla_name_textfield"..InstrumentIndex.."2"] = "panning"
  perilla_db["perilla_effect_textfield"..InstrumentIndex.."2"] = "0P"
  perilla_db["perilla"..InstrumentIndex.."2"] = 127
  
  perilla_db["perilla_name_textfield"..InstrumentIndex.."3"] = "width"
  perilla_db["perilla_effect_textfield"..InstrumentIndex.."3"] = "0W"
  perilla_db["perilla"..InstrumentIndex.."3"] = 0
  
  vb:column{
  
    style = "panel",
    margin = 2,
  
    id = "perilla_options_row"..InstrumentIndex,
    
    vb:popup{
      
      id = "framework"..InstrumentIndex,
      width = 25,
      items = {"none", "Yamaha MX"},
      notifier = function()
      
        perilla_activa = false
      
        if vb.views["framework"..InstrumentIndex].value == 1 then
        
          perilla_db["perilla_name_textfield"..InstrumentIndex.."1"] = "volume"
          perilla_db["perilla_effect_textfield"..InstrumentIndex.."1"] = "0L"
          perilla_db["perilla"..InstrumentIndex.."1"] = 192
  
          perilla_db["perilla_name_textfield"..InstrumentIndex.."2"] = "panning"
          perilla_db["perilla_effect_textfield"..InstrumentIndex.."2"] = "0P"
          perilla_db["perilla"..InstrumentIndex.."2"] = 127
  
          perilla_db["perilla_name_textfield"..InstrumentIndex.."3"] = "width"
          perilla_db["perilla_effect_textfield"..InstrumentIndex.."3"] = "0W"
          perilla_db["perilla"..InstrumentIndex.."3"] = 0
          
          for n = 4, 16 do
            perilla_db["perilla_name_textfield"..InstrumentIndex..n] = ""
            perilla_db["perilla_effect_textfield"..InstrumentIndex..n] = ""
            perilla_db["perilla"..InstrumentIndex..n] = 0
          end
          vb.views["perilla"..InstrumentIndex].value = 192
          vb.views["perilla_popup"..InstrumentIndex].value = 1
          vb.views["rotary_number_text"..InstrumentIndex].text = "1"
          vb.views["perilla_name_textfield"..InstrumentIndex].value = "volume"
          vb.views["perilla_effect_textfield"..InstrumentIndex].value = "OL"
          
            
          
        elseif vb.views["framework"..InstrumentIndex].value == 2 then
        
          local yamaha_mx_data = {{"cutoff", "4A", 63}, {"resonance", "47", 50}, {"chorus", "5D", 30}, {"reverb", "5B", 20}, {"attack", "49", 10}, {"decay", "4B", 10}, {"sustain", "1F", 40}, {"release", "48", 63}, {"volume", "07", 127}, {"panning", "0A", 63}, {"assing1", "10", 63}, {"assing2", "11", 63}, {}}
          
          for n = 1, 13 do
          
            perilla_db["perilla_name_textfield"..InstrumentIndex..n] = yamaha_mx_data[n][1]
            perilla_db["perilla_effect_textfield"..InstrumentIndex..n] = yamaha_mx_data[n][2]
            perilla_db["perilla"..InstrumentIndex..n] = yamaha_mx_data[n][3]
          
          end
          vb.views["perilla_popup"..InstrumentIndex].value = 1
          vb.views["rotary_number_text"..InstrumentIndex].text = "1"
          vb.views["perilla_name_textfield"..InstrumentIndex].value = yamaha_mx_data[1][1]
          vb.views["perilla_effect_textfield"..InstrumentIndex].value = yamaha_mx_data[1][2]
          vb.views["perilla"..InstrumentIndex].value = yamaha_mx_data[1][3]
        
        
        
        end
        
        perilla_activa = true
      
      end
      
    },
    
    vb:row{
  
    
      vb:rotary{ 
        min = 0,
        max = 255,
        value = 192,
        id = "perilla"..InstrumentIndex, 
        notifier = function()
      
          if perilla_activa == true then
      
            --print(vb.views["perilla_options_row"..InstrumentIndex].height)
            
            perilla_db["perilla"..InstrumentIndex..vb.views["perilla_popup"..InstrumentIndex].value] = vb.views["perilla"..InstrumentIndex].value
      
            local current_sequence = renoise.song().transport.edit_pos.sequence
            local current_line = renoise.song().transport.edit_pos.line
            current_line = current_line + 1
            if current_line > renoise.song():pattern(current_sequence).number_of_lines then 
              current_line = 1
              current_sequence = current_sequence + 1
              if current_sequence > #renoise.song().patterns then
                current_sequence = 1
              end    
            end
      
            local a = renoise.song():pattern(current_sequence):track(InstrumentIndex):line(current_line)
            
            if vb.views["framework"..InstrumentIndex].value == 2 then
              
              --renoise.song().tracks[InstrumentIndex].panning_column_visible = true
              if renoise.song():track(InstrumentIndex).panning_column_visible == false then 
                renoise.song():track(InstrumentIndex).panning_column_visible = true
              end
            
              --renoise.song().patterns[current_sequence].tracks[InstrumentIndex].lines[current_line].note_columns[1].panning_string = "M0"
              renoise.song():pattern(current_sequence):track(InstrumentIndex):line(current_line):note_column(1).panning_string = "M0"
            
            end
            
            if renoise.song():track(InstrumentIndex).visible_effect_columns < 2 then 
              renoise.song():track(InstrumentIndex).visible_effect_columns = 2 
            end   
          
            a:effect_column(1).number_string = vb.views["perilla_effect_textfield"..InstrumentIndex].value    
       
            a:effect_column(1).amount_value = vb.views["perilla"..InstrumentIndex].value
       
            a:note_column(1).instrument_value = InstrumentIndex-1
          
          end   
      
        end
      },
    
      vb:column{
      
        vb:popup{
          width = 25,
          items = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16"},
          id = "perilla_popup"..InstrumentIndex,
          notifier = function()
        
            perilla_activa = false --desactiva la perilla momentáneamente para que no se triggeree.
        
            if perilla_db["perilla_name_textfield"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)] == nil then 
          
              vb.views["perilla_name_textfield"..InstrumentIndex].value = ""
            
            else  
        
              vb.views["perilla_name_textfield"..InstrumentIndex].value = perilla_db["perilla_name_textfield"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)] 
            
            end 
          
            if perilla_db["perilla_effect_textfield"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)] == nil then 
          
              vb.views["perilla_effect_textfield"..InstrumentIndex].value = ""
            
            else   
          
              vb.views["perilla_effect_textfield"..InstrumentIndex].value =  perilla_db["perilla_effect_textfield"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)]
            
            end 
          
            if perilla_db["perilla"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)] == nil then
              vb.views["perilla"..InstrumentIndex].value = 0
            else
               vb.views["perilla"..InstrumentIndex].value = perilla_db["perilla"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)]
            end         
          
            vb.views["rotary_number_text"..InstrumentIndex].text = tostring(vb.views["perilla_popup"..InstrumentIndex].value)
            
            perilla_activa = true ---activa la perilla de nuevo para que el usuario pueda usarla. 
        
          end
        },
      
        vb:text{
          id = "rotary_number_text"..InstrumentIndex,
          text = "1"
        }
      
      },    
    
      vb:column{
        vb:textfield{ 
          value = "volume",
          id = "perilla_name_textfield"..InstrumentIndex, 
          width = 45,
          notifier = function()
        
            perilla_db["perilla_name_textfield"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)] = vb.views["perilla_name_textfield"..InstrumentIndex].value
          
          
        
          end 
        },  
        
        vb:textfield{  
          value = "0L",
          id = "perilla_effect_textfield"..InstrumentIndex, 
          width = 45,
          notifier = function()
        
            perilla_db["perilla_effect_textfield"..InstrumentIndex..tostring(vb.views["perilla_popup"..InstrumentIndex].value)] = vb.views["perilla_effect_textfield"..InstrumentIndex].value
        
          end
        } 
      } 
      
    }    
        
    
  }
  
  return vb.views["perilla_options_row"..InstrumentIndex]



end 
              
 
-- Create the Global_Column with the "Record"/"Practice" Button, the Lines per phrase, Lines per Beat Global Values and the "Add"/"Delete" track button
 
 local Global_Column = vb:column {
  style = "panel",
  vb:horizontal_aligner {
    mode = "left",
    spacing = 0,
    
    
    vb:button{
      text = "»",
      tooltip = "Start the song",
      id = "start_playing_button",
      pressed = function()
      

        if renoise.song().transport.playing == true then
          vb.views["start_playing_button"].color = {0, 0, 0}
          renoise.song().transport:stop()
          if vb.views["my_text"].text == "Practice" then
            for i = 1, #renoise.song().patterns do
              renoise.song():pattern(i):clear()
            end 
          end  
          
          for instrument = 1, #renoise.song().instruments do
           --- there_are_phrases_playing_in_this_track[instrument] = false
            sequence_of_phrases_played_in_this_track[instrument] = nil
          end  
        else ---if playback is not playing then... 
        
          vb.views["start_playing_button"].color = {0xb7, 0xd5, 0xac}
        
          ----if there are phrases playing, then write them in the edit pattern.
          
          local current_sequence = renoise.song().transport.edit_pos.sequence
          local current_line = renoise.song().transport.edit_pos.line
          if vb.views["my_text"].text == "Practice" then
            current_sequence = 1
            current_line = 1
          end            
        
          for instrument = 1, #renoise.song().instruments do            
          
            for phrase = 1, #renoise.song():instrument(instrument).phrases do
            
              if is_pushed[tostring(instrument)..tostring(phrase)] == true then
              
                if renoise.song():track(instrument).visible_effect_columns < 2 then 
                  renoise.song():track(instrument).visible_effect_columns = 2 
                end 
            
                local a = renoise.song():pattern(current_sequence):track(instrument):line(current_line) 
       
                a:note_column(1).note_value = 48
       
                a:effect_column(2).number_string = "0Z"    
       
                a:effect_column(2).amount_value = phrase
       
                a:note_column(1).instrument_value = instrument-1 
                
                there_are_phrases_playing_in_this_track[instrument] = true
                sequence_of_phrases_played_in_this_track[instrument] = {{phrase, renoise.song():instrument(instrument):phrase(phrase).number_of_lines, current_sequence, current_line }} 
                
                break
              
                --instrument_playback_position_start[tostring(instrument)] = {1, 1, phrase} 
       
              end
            
            end  
          
        
                        
           end 
           
           renoise.song().transport:start_at(renoise.SongPos(current_sequence, current_line))       
        
      end 
      
    end  
      
    },   
      
    vb:space{ width = 5},    

    vb:text {
      id = "my_text",
      text = "Practice",
      visible = true
    },

    vb:button {
      id = "Record_Button_Color",
      color = {0x80, 0x80, 0x80},
      text = nil,
      tooltip = "Change to Practice mode or Record mode",
      notifier = function()
        local my_text_view = vb.views.my_text
        local Record_Button_Color_view = vb.views.Record_Button_Color
        if my_text_view.text == "Practice" then
         my_text_view.text = "Record"
         Record_Button_Color_view.color = {0xff, 0x00, 0x5a}
         local Practice = false
         
         local a = renoise.song():pattern(1)
         
         while #renoise.song().tracks-2 < #renoise.song().instruments do 
           renoise.song():insert_track_at(#renoise.song().tracks-2+1)
         end  
         
         for instrument = 1, #renoise.song().instruments do 
         
            if renoise.song():track(instrument).visible_effect_columns < 2 then 
              renoise.song():track(instrument).visible_effect_columns = 2 
            end 
            if renoise.song():track(instrument).panning_column_visible == false then 
              renoise.song():track(instrument).panning_column_visible = true
            end           
          
            for perilla = 1, 16 do
            
              if perilla_db["perilla_effect_textfield"..instrument..perilla] ~= nil then 
            
                local b = a:track(instrument):line(perilla)
                b:note_column(1).instrument_value = instrument-1
                b:effect_column(1).number_string = perilla_db["perilla_effect_textfield"..instrument..perilla] 
                b:effect_column(1).amount_value = perilla_db["perilla"..instrument..perilla]
                if vb.views["framework"..instrument].value == 2 then b:note_column(1).panning_string = "M0" end
                
              end  
              
            
              
            
            end
            
            
         end    
         
        elseif my_text_view.text == "Record" then
         my_text_view.text = "Practice"
         Record_Button_Color_view.color = {0x80, 0x80, 0x80}
         local Practice = true
        end 
      end
    },
    
    
    vb:text {
      text = "    "
    },
    
    vb:text {
      text = "Global Lines Per Phrase"
    },
    
    vb:button {
      text = "<",
      notifier = function()
        local LPP_Button_view = vb.views.LPP_Button
        local n = LPP_Button_view.text
        local LPP_to_Number = tonumber(n)    
        if LPP_to_Number > 1 then    
         local LPP_to_Number = LPP_to_Number - 1   
         local LPP_to_String = tostring(LPP_to_Number) 
         LPP_Button_view.text = LPP_to_String
        end
      end
    },
    
    vb:text {
      id = "LPP_Button",
      text = "32"
      
      
    },
    
    vb:button {
      text = ">",
      notifier = function()
        local LPP_Button_view = vb.views.LPP_Button
        local n = LPP_Button_view.text
        local LPP_to_Number = tonumber(n)    
        if LPP_to_Number < renoise.InstrumentPhrase.MAX_NUMBER_OF_LINES then    
         local LPP_to_Number = LPP_to_Number + 1    
         local LPP_to_String = tostring(LPP_to_Number) 
         LPP_Button_view.text = LPP_to_String
        end
      end
    },  
    
    vb:text {
      text = "    "
    },
    
    vb:text {
      text = "Global Lines per Beat"
    },
    
    vb:button {
      text = "<",
      notifier = function()
        local LPB_Button_view = vb.views.LPB_Button
        local n1 = LPB_Button_view.text
        local LPB_to_Number = tonumber(n1)    
        if LPB_to_Number > 1 then    
         local LPB_to_Number = LPB_to_Number - 1   
         local LPB_to_String = tostring(LPB_to_Number) 
         LPB_Button_view.text = LPB_to_String
        end
      end
    },
      
    vb:text {
      id = "LPB_Button",
      text = "4"
      
      
    },
    
    vb:button {
      text = ">",
      notifier = function()
        local LPB_Button_view = vb.views.LPB_Button
        local n1 = LPB_Button_view.text
        local LPB_to_Number = tonumber(n1)    
        if LPB_to_Number < 256 then    
         local LPB_to_Number = LPB_to_Number + 1   
         local LPB_to_String = tostring(LPB_to_Number) 
         LPB_Button_view.text = LPB_to_String
        end
      end
    }, 
    
    vb:space{
      width = 15
    },   
    
    vb:text{
      text = "Global quantization"
    },
    
    vb:popup{
      id = "global_quantization",
      items = {"Phrase", "No quantization"}
    },    
    
    vb:text {
      text = "    "
    },
    
    vb:text {
      text = "Insert track",
      visible = true
    },
    
    vb:button {
      
      text = "+",
      tooltip = "Add a track after the last track inserted",
      visible = true,
      notifier = function()
      
        add_track_is_pushed = true
        renoise.song():insert_instrument_at(#renoise.song().instruments+1)---add a new instrument.
        
        current_number_of_instruments = #renoise.song().instruments
        
        while #renoise.song().tracks-2 < #renoise.song().instruments do 
          renoise.song():insert_track_at(#renoise.song().tracks-2+1)
        end  
        
        local this_instrument = #renoise.song().instruments ---store the last instrument added into this variable, so the value gets fixed.
        
        
        
        if vb.views["Superior Column-"..tostring(this_instrument)] == nil then
        ---if track does not exist then create the track...
        
        Superior_Column_dictionary["Superior Column-"..tostring(this_instrument)] = vb:column{
          width = 110,
          style = "group",
          id = "Superior Column-"..tostring(this_instrument),
          
          create_rotary_column(this_instrument),
      
          vb:row{
--- + button - this is where the creation of the + button for the phrase beginns, its a long program...    
            vb:button{            
              text = "+",
              tooltip = "Add a phrase on this track",
              visible = true,
              notifier = function()
              
              

                local Biggest_Track_phrases_before = BiggestTrackPhrases()---check the current number of phrases for the biggest track.
                renoise.song().instruments[this_instrument]:insert_phrase_at(#renoise.song():instrument(this_instrument).phrases+1)---add the phrase.
                
                local Biggest_Track_phrases_after = BiggestTrackPhrases()---check if the biggest track changed.
        
                local phrase = #renoise.song():instrument(this_instrument).phrases
                
                renoise.song().instruments[this_instrument].phrases[phrase]:clear() ---THIS IS to get rid of the c4 note.
        
                if vb.views["Phrase Column-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)] == nil then
                ---if phrase does not exist then create the phrase...
                  vb:column{
                    width = 110,
                    style = "panel",
                    id = "Phrase Column-"..tostring(this_instrument)..tostring(phrase),
          
    
                    vb:column{    
                      vb:row{         
                        vb:button {
                          id = "Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                          color = {0xeb, 0xab, 0x34},
                          text = "¤",
                          notifier = function()
                          end
                        },      
                        vb:text{
                          text = "Hidden",
                          id = "Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                          visible = false
                        },
                        vb:textfield{
                          width = 59,
                          text = "Phrase-"..tostring(#renoise.song():instrument(this_instrument).phrases+1),
                          id = "Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)
                        },
                        vb:button{
                          text = "Play",
                          id = "play_button_"..tostring(this_instrument)..tostring(phrase),
                          tooltip = "Play this phrase",
                          pressed = function()
                          
                            write_phrase_into_pattern(this_instrument, phrase)
                          
                          end
                        }        
                      }      
                    },
          
                    vb:column{
                      id = "Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                      visible = false,    
                      vb:row{      
                        vb:button{
                          text = "C",
                          tooltip = "Copy this phrase's content",
                          notifier = function()
                            last_phrase_copied = {this_instrument, phrase}
                          end
                        },
                          
                        vb:button{                            
                          text = "↑",
                          tooltip = "Transpose this phrase one semitone up",
                          notifier = function()
                          
                            transpose_phrase(1, this_instrument, phrase)
                            
                          end
                        },
                          
                        vb:button{             
                          text = "↓",
                          tooltip = "Transpose this phrase one semitone down",
                          notifier = function()
                          
                            transpose_phrase(-1, this_instrument, phrase)
                            
                          end
                        },    
                      
                        vb:button{
                          color = {0xff, 0xff, 0x00},
                          text = "L",
                          id = "legato_mode"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                          tooltip = "Activate the legato mode for this phrase",
                          notifier = function()
                          
                            local legato = "legato_mode"..tostring(this_instrument)..tostring(phrase)
                              
                            if legato_is_pushed[legato] == false then 
                              vb.views[legato].color = {0xff, 0xff, 0x00} 
                              legato_is_pushed[legato] = true
                              
                            elseif legato_is_pushed[legato] == nil or legato_is_pushed[legato] == true then 
                              vb.views[legato].color = {0, 0, 0}  
                              legato_is_pushed[legato] = false
                              
                            end  
                              
                          end
                        },
                        
                        vb:button{
                          text = "X",
                          tooltip = "Duplicate the content of this phrase",
                          notifier = function()
                          
                            local a = renoise.song():instrument(this_instrument):phrase(phrase)
                            local sum = a.number_of_lines
                            
                            a.number_of_lines = sum * 2
                            
                            for i = 1, sum do
                            
                              for column = 1, #a:line(1).note_columns do
                              
                                a:line(i + sum):note_column(column).note_value = a:line(i):note_column(column).note_value
                                a:line(i + sum):note_column(column).volume_value = a:line(i):note_column(column).volume_value
                                a:line(i + sum):note_column(column).panning_value = a:line(i):note_column(column).panning_value
                                a:line(i + sum):note_column(column).delay_value = a:line(i):note_column(column).delay_value
                                a:line(i + sum):note_column(column).effect_number_value = a:line(i):note_column(column).effect_number_value
                                a:line(i + sum):note_column(column).effect_amount_value = a:line(i):note_column(column).effect_amount_value  
                                                                                            
                              end  
                              
                              for column = 1, #a:line(1).effect_columns do
                                
                                a:line(i + sum):effect_column(column).number_value = a:line(i):effect_column(column).number_value
                                a:line(i + sum):effect_column(column).amount_value = a:line(i):effect_column(column).amount_value   
                                
                              end                              
                              
                            end  
                          
                          
                          
                          end
                          
                        }      
                      },      
                      vb:row{      
                        vb:button{
                          text = "P",
                          tooltip = "Paste the last content copied into this phrase",
                          notifier = function()
                      
                            renoise.song():instrument(this_instrument):phrase(phrase):copy_from(renoise.song():instrument(last_phrase_copied[1]):phrase(last_phrase_copied[2]))
                          end
                        },
                        vb:button{
                          text = "D",
                          tooltip = "Delete this phrase's content",
                          notifier = function()
                            renoise.song().instruments[this_instrument].phrases[phrase]:clear()
                          end
                        },
                        vb:button{
                          text = "G",
                          tooltip = "Go this Phrase editor",
                          notifier = function()
                            renoise.song().selected_instrument_index = this_instrument
                            renoise.song().selected_phrase_index = phrase
                            renoise.app().window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_PHRASE_EDITOR  
                            ----now hide the phrase's column:
                            vb.views.Hide_Show_Phrases_Column_Button.color = {0x10, 0x90, 0xff}
                            vb.views["Phrases_column"].visible = false  
                            vb.views.Show_Hidden.text = "Hidden"              
                    
                          end
                        },
                        
                        vb:button{
                          text = "■",
                          tooltip = "Apply pitch correction to this phrase, given the selected major scale",
                          notifier = function()
                          
                            Pitch_corrector(this_instrument, phrase)
                          
                          end  
                          
                        },
                        
                        
                        vb:popup{
                          width = 17,
                          tooltip = "Choose the quantization setup per phrase. Parameters are Global quantization, Phrase and No quantization.",
                          items = { "G", "P", "N" },
                          value = 1,
                          id = "quantization_setup_phrase"..tostring(this_instrument)..tostring(phrase)
                        }  
                                  
                      }      
                    }
      
                } 
        
                if #renoise.song():instrument(this_instrument).phrases < 10 then vb.views["Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Phrase-00"..tostring(#renoise.song():instrument(this_instrument).phrases)
                elseif #renoise.song():instrument(this_instrument).phrases < 100 then vb.views["Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Phrase-0"..tostring(#renoise.song():instrument(this_instrument).phrases)
                end       
                end
        
        
                if vb.views["S/H VAR"].text == "Shown" then
                         
                  vb.views["Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].visible = true 
              
                  vb.views["Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Shown"
                
                  vb.views["Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].color = {0xeb, 0xab, 0x34} 
                          
                end     
        
                if vb.views["S/H VAR"].text == "Hidden" then    
          
                  vb.views["Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].visible = false
          
                  vb.views["Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Hidden"
          
                  vb.views["Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].color = {0x60, 0x60, 0x60}
          
                end  
                
                renoise.song():instrument(this_instrument):phrase(phrase).number_of_lines = tonumber(vb.views["LPP_Button"].text)  
                renoise.song():instrument(this_instrument):phrase(phrase).lpb = tonumber(vb.views["LPB_Button"].text)     
              
        
                ---Now, there are two situation when we need to update the GUI. One is when we are in the last page of a track and the phrases do not make for the 10 phrase limit. The other case is when we are after the last page of a track that filled all the 10 phrases limit.
        
                local IsRouteB = nil
                local IsRouteA = nil
                local constant = Number_of_phrases_per_page - 1
                local Number_Of_Pages_For_This_Track = #renoise.song():instrument(this_instrument).phrases - constant
                if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
        
                local array = {} 
                for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                table.insert(array, column)
       
                end
        
                local IsColumn --- we need to write this code in order to find the number of column (1 to 10) where we are going to place our phrase.
                for i = 1, #array do
                  if this_instrument == array[i] then 
                    IsColumn = i
                    break
                  end
                end    
        
                for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(this_instrument)-1 do
          
                  ---this is route A:
                  if tonumber(vb.views["Page_among_phrases_text"].text) == page and Limit_values_For_Phrases(this_instrument)[page][2] <= Number_of_phrases_per_page + page - 1 then
            
                    vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(tostring(#renoise.song():instrument(this_instrument).phrases))]) 
                    IsRouteA = true  
                    print("route A")                
                    break
                  end
                end    
        
                ---this is route B:  
                if tonumber(vb.views["Page_among_phrases_text"].text) == #Limit_values_For_Phrases(this_instrument) then
                    vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["space"..tostring(this_instrument)])
                    vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(tostring(#renoise.song():instrument(this_instrument).phrases))]) 
                    IsRouteA = false 
                    IsRouteB = true
                    print("route B")                   
                end
        
               ---So far we're good. The last thing we need to do is to update the master track.. if needed.
        
                if Biggest_Track_phrases_after - Biggest_Track_phrases_before == 1 then
                  if vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases)] == nil then
                    vb:column{
                      id = "Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases),        
                      vb:button{
                        text = "Play-"..tostring(#renoise.song():instrument(this_instrument).phrases),
                        id = "Play Button from master"..tostring(#renoise.song():instrument(this_instrument).phrases),
                        pressed = function()
                          
                          play_button_for_master(phrase)
                          
                        end  
                          
                      }              
                    }
                  end  
      
                  if #renoise.song():instrument(this_instrument).phrases < 10 then vb.views["Play Button from master"..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Play-00"..tostring(#renoise.song():instrument(this_instrument).phrases)   
                  elseif #renoise.song():instrument(this_instrument).phrases < 100 then vb.views["Play Button from master"..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Play-0"..tostring(#renoise.song():instrument(this_instrument).phrases)
                  end
                  ---
        
                  if IsRouteA == true then
            
                    vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases)])
          
                  end
          
                  if IsRouteB == true and #renoise.song():instrument(this_instrument).phrases == 1 then
          
                    vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases)])
            
                  end    
          
                end  
              
              end            
            },
--- "-" button            
            vb:button{
              text = "-",
              tooltip = "Delete a phrase on this track",
              visible = true,
              notifier = function()

                if #renoise.song():instrument(this_instrument).phrases > 0 then 
                  local routeA  
                  local numberOfPhrases_avant = #renoise.song():instrument(this_instrument).phrases---check the number of phrases in this track before deleting the last phrase.
                  local Biggest_Track_phrases_before = BiggestTrackPhrases()---check the current number of phrases for the biggest track.
                  
                  
                  renoise.song().instruments[this_instrument]:delete_phrase_at(#renoise.song():instrument(this_instrument).phrases)--delete the last phrase.
                  local numberOfPhrases_apres = #renoise.song():instrument(this_instrument).phrases---check the number of phrases in this track after deleting the last phrase.
                  local Biggest_Track_phrases_after = BiggestTrackPhrases()---check if the biggest track changed.
                  local IsSpaceNeeded = nil
          
                       
        
                ---Now, there are two situation when we need to update the GUI. Route A represents the situation where there are zero phrases because we just deleted the first and only phrase and thus we'll need to agregate an space to not collapse the view. Route B is when there are still phrases in the view, even after deleting the last phrase.
        
                  ---local IsRouteB = nil
                  local constant = Number_of_phrases_per_page - 1
                  local Number_Of_Pages_For_This_Track = #renoise.song():instrument(this_instrument).phrases - constant +1
                  if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
          
                  local array2 = {} 
                  for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                  table.insert(array2, column)
       
                  end
        
                  local IsColumn --- we need to write this code in order to find the number of column (1 to 10) where we are going to place our phrase.
                  for i = 1, #array2 do
                    if this_instrument == array2[i] then 
                      IsColumn = i
                      break
                    end
                  end              
          
                  ---this is route A
                  if (Limit_values_For_Phrases(this_instrument) == nil and numberOfPhrases_avant-numberOfPhrases_apres == 1) and tonumber(vb.views["Page_among_phrases_text"].text) == 1 then
                    vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(1)]) 
                    if vb.views["space"..tostring(this_instrument)] == nil then            
                      vb:space{width = 110, id = "space"..tostring(this_instrument)} 
                    end 
                    vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["space"..tostring(this_instrument)])
                    routeA = true
                  end  
          
                  ---this is route B:
                  if Limit_values_For_Phrases(this_instrument) ~= nil then
            
                    for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(this_instrument)+1 do
          
                      if tonumber(vb.views["Page_among_phrases_text"].text) == page then
                
                       --- IsRouteB = true
            
            
                        vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)]) 
     
        
                        if Limit_values_For_Phrases(this_instrument)[tonumber(vb.views["Page_among_phrases_text"].text)] == nil  then
          
                          if vb.views["space"..tostring(this_instrument)] == nil then            
                          vb:space{width = 110, id = "space"..tostring(this_instrument)} 
                          end 
        
                          vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["space"..tostring(this_instrument)])
       
                        end  
                
              
                      end  
              
                    end
                  end    
            
                    ---Now lets make some code in case we are at the last page with only one phrase. In that case we'll need to update all the tracks and change the page.
                    if Limit_values_For_Phrases(this_instrument) ~= nil then
             
             
                      if Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 and #Limit_values_For_Phrases(this_instrument)+1 == tonumber(vb.views["Page_among_phrases_text"].text)  then---if we'll need to update the master column and we are also in the last page of the track...
                
              
                        ---print("hi")
                
                        vb.views["Page_among_phrases_text"].text = tostring(tonumber(vb.views["Page_among_phrases_text"].text)-1)
                
                        local array = {}
                        for i = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                        table.insert(array, i)
       
                        end
       
                        for i = 1, #array do
       
                          ---lets remove the content first for each given track.
                          if Limit_values_For_Phrases(array[i]) == nil or tonumber(Page_among_phrases_text.text)+1 > #Limit_values_For_Phrases(array[i]) then
                            if vb.views["space"..tostring(array[i])] ~= nil then   
                              vb.views["column-"..tostring(i)]:remove_child(vb.views["space"..tostring(array[i])])
                            end            
         
                          else
                            for phrase = Limit_values_For_Phrases(array[this_instrument])[tonumber(Page_among_phrases_text.text)+(1)][1], Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)+(1)][2] do                                        
                              vb.views["column-"..tostring(i)]:remove_child(vb.views["Phrase Column-"..tostring(array[i])..tostring(phrase)])
                            end
                     
                          end  
         
                          ---now lets add new content for the new page.
                          if Limit_values_For_Phrases(array[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[i]) then 
                            if vb.views["space"..tostring(array[i])] == nil then
                              vb:space{width = 110, id = "space"..tostring(array[i])}
                            end  
                      
                            vb.views["column-"..tostring(i)]:add_child(vb.views["space"..tostring(array[i])]) 
                      
         
                          else
                  

                            for phrase = Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)][2] do                                        
                      vb.views["column-"..tostring(i)]:add_child(vb.views["Phrase Column-"..tostring(array[i])..tostring(phrase)])
                            end
                     
                     
                          end   
         
         
           
         
         
                        end
       
                        if limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)] ~= nil then
                          for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][2] do
                            vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
                          end
                        end  
       
                        if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
                          for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
                            if vb.views["Master Column dictionary"..tostring(master)] == nil then
                              MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
                                id = "Master Column dictionary"..tostring(master),
        
                                vb:button{
                                text = "Play-"..tostring(master),
                                id = "Play Button from master"..tostring(master)
                                }             
                              }
                            end    
                            vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
                          end
                        end 
                
                        vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases+1)]) 
                 
         
             
                     else
             
                       for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(this_instrument)+1 do
          
                         if tonumber(vb.views["Page_among_phrases_text"].text) == page and Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 then 
                           vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases+1)])       
                 
                         end    
                       end
                     end 
             
                   end 
    
      
            
                    if routeA == true then ---if we need to update the master column and we just deleted the first and only phrase of the track.
                      if Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 then
                        vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases+1)])
                      end  
                    end
              
              
                  
             
           
                end
                
                vb.views["play_button_"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["Phrase Column-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["legato_mode"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["quantization_setup_phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                vb.views["Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)] = nil
                
              end
             
            }    
              
       
      
      
            },
    
          vb:row{
  
            vb:textfield{
              text = "Track-"..tostring(this_instrument),
              id = "Track_Number_text"..tostring(this_instrument) 
            },
            
            vb:button{
              text = "S",
              tooltip = "Stop this track",
              notifier = function()
                
                if instrument_playback_position_start[tostring(this_instrument)] ~= nil then ---if this track has already been played:
                  local phrase = instrument_playback_position_start[tostring(this_instrument)][3]
                
                  if is_pushed[tostring(this_instrument)..tostring(phrase)] == true then ---if the phrase is pushed.
                    
                    is_pushed[tostring(this_instrument)..tostring(phrase)] = false
                    vb.views["play_button_"..tostring(this_instrument)..tostring(phrase)].color = {0,0,0}
                
                    if renoise.song().transport.playing == true then
                    
                      local current_sequence = renoise.song().transport.edit_pos.sequence
                      local current_line = renoise.song().transport.edit_pos.line
                      local line = renoise.song():pattern(current_sequence):track(this_instrument):line(current_line+1):note_column(1)
                                          
                      line.note_value = 120 
       
                      line.instrument_value = this_instrument-1 
                      
                    end
                    
                  end
                  
                end      
         
          
                
              end
            },
            
            vb:space{
              width = 110-70
            }              
      
          }
    
        }
        
        if  this_instrument < 10 then vb.views["Track_Number_text"..tostring(this_instrument)].text = "Track-00"..tostring(this_instrument)
        elseif this_instrument < 100 then vb.views["Track_Number_text"..tostring(this_instrument)].text = "Track-0"..tostring(this_instrument)
        end
        
      end --- este es el "end" del condicional "if" en caso de que la columna no exista. 
      
      while Page_among_tracks_text.text == "1" do--- si los tracks en la columna no están completos, es decir, no llegan a 10, entonces agrega uno a la columna.
        if #renoise.song().instruments <= Number_of_phrases_per_page then
          vb.views["All_Superior_Tracks_Row"]:add_child(vb.views["Superior Column-"..tostring(this_instrument)])
          if vb.views["space"..tostring(this_instrument)] == nil then            
            vb:space{width = 110, id = "space"..tostring(this_instrument)}
          end   
          ---vb.views["column-"..tostring(this_instrument)]:add_child(vb.views["space"..tostring(this_instrument)])
        end
        --print(vb.views["Superior Column-"..tostring(1)].width)
        break
      end  
      
      
        
       
       
       
       
               
      end ----este en el end del notifier de "add track".      
          
    },
    
    
    vb:space{
      width = 8
    },  
    
    vb:text {
      text = "Delete track",
      visible = true
      
      
    },
    
    vb:button {
      text = "-",
      tooltip = "Delete the last track inserted",
      visible = true,
      notifier = function()
       
      
        local number_of_phrases_before_deleting_instrument = #renoise.song():instrument(#renoise.song().instruments).phrases
      
        if #renoise.song().instruments > 1 then ---Renoise requires at least one instrument.
          
          delete_track_is_pushed = true
          
          local quantity_of_track_pages_before = #Limit_values_For_Tracks()
          
          local number_of_phrases_for_last_track_before_deleting_first_limit 
          local number_of_phrases_for_last_track_before_deleting_second_limit
          
          
          if Limit_values_For_Phrases(#renoise.song().instruments) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(#renoise.song().instruments) then 
            number_of_phrases_for_last_track_before_deleting_first_limit = nil
            number_of_phrases_for_last_track_before_deleting_second_limit = nil
            
          else 
            number_of_phrases_for_last_track_before_deleting_first_limit = Limit_values_For_Phrases(#renoise.song().instruments)[tonumber(Page_among_phrases_text.text)][1]
            number_of_phrases_for_last_track_before_deleting_second_limit = Limit_values_For_Phrases(#renoise.song().instruments)[tonumber(Page_among_phrases_text.text)][2]
                        
          end  
          
          local biggest_track_phrases_before_deleting_last_instrument = BiggestTrackPhrases() ---obtenemos el número de phrases del track más grande antes de que el último instrumento sea eliminado. Esto nos indicará si hubo cambios en el master track.
          
          local master_first_limit = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1]---obtenemos el primer límite del máster antes de eliminar el track, esto para luego poder eliminar botones del máster en caso de que hayamos borrado el track más grande.
          local master_second_limit = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2]
          
          renoise.song():delete_instrument_at(#renoise.song().instruments) ---delete the last instrument. 
          
          current_number_of_instruments = #renoise.song().instruments         
          
          if #Limit_values_For_Tracks() ~= 1 or quantity_of_track_pages_before == 2 then ---if we are on a page other than the first page.          
            if #Limit_values_For_Tracks()+1 == tonumber(Page_among_tracks_text.text) then ---if we are at the last page then delete... 
              Page_among_tracks_text.text = tostring(tonumber(Page_among_tracks_text.text)-1) --resta uno al número de página entre tracks.
              for i = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1]+1, Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2]+1 do                                
                vb.views["All_Superior_Tracks_Row"]:remove_child(vb.views["Superior Column-"..tostring(i)])
              end  
              
              for i = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do                                
                vb.views["All_Superior_Tracks_Row"]:add_child(vb.views["Superior Column-"..tostring(i)])
              end 
               
              ---now delete the phrases too.
              
              local tracks = {} ---first we store in this array the tracks that are going to be modified.
              for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1]+1, Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2]+1 do 
                table.insert(tracks, column)       
              end
              
              
              for i = 1, #tracks-1 do
                if Limit_values_For_Phrases(tracks[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(tracks[i])  then ---si el track no tiene phrases en esta página...  
                  vb.views["column-"..tostring(i)]:remove_child(vb.views["space"..tostring(tracks[i])])---borra el espacio.                   
                else ---si tiene entonces borra las phrases..
                  for phrase = Limit_values_For_Phrases(tracks[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(tracks[i])[tonumber(Page_among_phrases_text.text)][2] do               
                    vb.views["column-"..tostring(i)]:remove_child(vb.views["Phrase Column-"..tostring(tracks[i])..tostring(phrase)]) 
                  end                                     
                end    
              end  
              
              ---this is a step that we do to delete the last track:
              
              if number_of_phrases_for_last_track_before_deleting_first_limit == nil then
                vb.views["column-"..tostring(Number_of_tracks_per_page)]:remove_child(vb.views["space"..tostring(tracks[#tracks])])

              else
                for phrase = number_of_phrases_for_last_track_before_deleting_first_limit, number_of_phrases_for_last_track_before_deleting_second_limit do
                  vb.views["column-"..tostring(Number_of_tracks_per_page)]:remove_child(vb.views["Phrase Column-"..tostring(tracks[#tracks])..tostring(phrase)]) 
                end                  
              end 
              
              
              ---now add the new phrases  
              
              local tracks_add = {} ---first we store in this array the tracks that are going to be modified.
              for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                table.insert(tracks_add, column)       
              end   
              
              for i = 1, #tracks_add do
                if Limit_values_For_Phrases(tracks_add[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(tracks_add[i]) then ---si el track no tiene phrases en esta página... 
                  if vb.views["space"..tostring(tracks_add[i])] == nil then            
                    vb:space{width = 110, id = "space"..tostring(tracks_add[i])} 
                  end 
                  vb.views["column-"..tostring(i)]:add_child(vb.views["space"..tostring(tracks_add[i])])  ---adhiere un espacio.  
                  
                else ---si tiene phrases entonces agrégalas..
                  for phrase = Limit_values_For_Phrases(tracks_add[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(tracks_add[i])[tonumber(Page_among_phrases_text.text)][2] do ---add the phrases..               
                    vb.views["column-"..tostring(i)]:add_child(vb.views["Phrase Column-"..tostring(tracks_add[i])..tostring(phrase)]) 
                  end                                   
                end    
              end                    
                
              
                     
             
             
            end 
            
          elseif #Limit_values_For_Tracks() == 1 then ---else if the page is the first one...            
            vb.views["All_Superior_Tracks_Row"]:remove_child(vb.views["Superior Column-"..tostring(#renoise.song().instruments+1)])
            
            ---borra las phrases
            
              if number_of_phrases_for_last_track_before_deleting_first_limit == nil then
                ---vb.views["column-"..tostring(#renoise.song().instruments+1)]:remove_child(vb.views["space"..tostring(#renoise.song().instruments+1)])

              else
                for phrase = number_of_phrases_for_last_track_before_deleting_first_limit, number_of_phrases_for_last_track_before_deleting_second_limit do
                  vb.views["column-"..tostring(#renoise.song().instruments+1)]:remove_child(vb.views["Phrase Column-"..tostring(#renoise.song().instruments+1)..tostring(phrase)])
                  
                end   
               
                if vb.views["space"..tostring(#renoise.song().instruments+1)] == nil then            
                  vb:space{width = 110, id = "space"..tostring(#renoise.song().instruments+1)}
                end  
                vb.views["column-"..tostring(#renoise.song().instruments+1)]:add_child(vb.views["space"..tostring(#renoise.song().instruments+1)]) ---tuvimos que agregar un espacio después de quitar las phrases, esto es para tener congruencia con los otros botones.                               
              end 
        
          
          end  
          
          ---now we need to use the function BiggestTrackPhrases() to test master changes and also to test situations where the biggest track (aka the track with more phrases) is deleted and thus we need to make changes.
          local biggest_track_now = nil
          local biggest_track_phrases_now = 0
          if biggest_track_phrases_before_deleting_last_instrument ~= BiggestTrackPhrases() then ---si el que borramos era el track más grande entonces:
            ---tenemos que encontrar el nuevo track más grande:
            for track = 1, #renoise.song().instruments  do
              if #renoise.song():instrument(track).phrases > biggest_track_phrases_now then
                biggest_track_phrases_now = #renoise.song():instrument(track).phrases
                biggest_track_now = track---ya obtuvimos entonces el que es ahora el track más grande.                             
              end
            end 
                                  
            ----ahora tenemos que actualizar la columna de phrases, pero primero tenemos que quitar las phrases que hay.            
            
            local tracks_before = {}
            for track = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
              table.insert(tracks_before, track)
            end
            
            for i = 1, #tracks_before do
              if Limit_values_For_Phrases(tracks_before[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(tracks_before[i]) then 
                if vb.views["space"..tostring(tracks_before[i])] == nil then            
                  vb:space{width = 110, id = "space"..tostring(tracks_before[i])} 
                end 
                vb.views["column-"..tostring(i)]:remove_child(vb.views["space"..tostring(tracks_before[i])])  ---adhiere un espacio. 
              
              else 
                for phrase = Limit_values_For_Phrases(tracks_before[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(tracks_before[i])[tonumber(Page_among_phrases_text.text)][2] do ---delete the phrases..               
                  vb.views["column-"..tostring(i)]:remove_child(vb.views["Phrase Column-"..tostring(tracks_before[i])..tostring(phrase)]) 
                end  
              end                                        
            end
            
              ---ahora actualizamos el master quitando botones:
                 
            for i = master_first_limit, master_second_limit do
              vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(i)]) 
            end   
                        
            ----ahora agregamos las phrases para la nueva página (página entre frases):
            if biggest_track_now == nil then ---primero actualizamos la página.
              Page_among_phrases_text.text = "1"
            else  
              Page_among_phrases_text.text = tostring(#Limit_values_For_Phrases(biggest_track_now))
            end  ---en resumen: si los demás tracks no tienen frases regrésame a la página 1, sino, llévame a la página que es igual al número de páginas del track más grande.
           
            
            local tracks_now = {}
            for track = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
              table.insert(tracks_now, track)
            end            
            
            for i = 1, #tracks_now do
              if Limit_values_For_Phrases(tracks_now[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(tracks_now[i]) then 
                if vb.views["space"..tostring(tracks_now[i])] == nil then            
                  vb:space{width = 110, id = "space"..tostring(tracks_now[i])} 
                end 
                vb.views["column-"..tostring(i)]:add_child(vb.views["space"..tostring(tracks_now[i])])  ---adhiere un espacio. 
              
              else 
                for phrase = Limit_values_For_Phrases(tracks_now[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(tracks_now[i])[tonumber(Page_among_phrases_text.text)][2] do ---delete the phrases..               
                  vb.views["column-"..tostring(i)]:add_child(vb.views["Phrase Column-"..tostring(tracks_now[i])..tostring(phrase)]) 
                end  
              end                                        
            end 
            
              ---ahora actualizamos el master agregando botones:
            
            for i = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
              vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(i)]) 
            end   
                 
            
                              
          
          end ---end de: si el que borramos era el track más grande.
          
            
        
          
        end  
        
        
    
            
        
        
        vb.views["perilla_options_row"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["framework"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["perilla"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["perilla_popup"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["rotary_number_text"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["perilla_name_textfield"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["perilla_effect_textfield"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["Superior Column-"..tostring(#renoise.song().instruments+1)] = nil
        vb.views["Track_Number_text"..tostring(#renoise.song().instruments+1)] = nil
        
        for phrase = 1, number_of_phrases_before_deleting_instrument do
        
          vb.views["play_button_"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
          vb.views["Phrase Column-"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
          vb.views["Show_Options_Column_button"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
          vb.views["Show_Options_Column_text"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
          vb.views["Number_Of_Phrase"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
          vb.views["legato_mode"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
          vb.views["quantization_setup_phrase"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil         
          vb.views["Options Column of Phrase-"..tostring(#renoise.song().instruments+1)..tostring(phrase)] = nil
         
        end  
          
       
        

      end
    },
    
    
    vb:space{ width = 15 },
    
    vb:button{
    
      tooltip = "Show chord buttons",
    
      notifier = function()
      
        if vb.views["row where chord buttons are contained"].visible == false then
          vb.views["row where chord buttons are contained"].visible = true          
          
        elseif vb.views["row where chord buttons are contained"].visible == true then  
          vb.views["row where chord buttons are contained"].visible = false
         
        end   
      
      end
    
    },    
    
    vb.views["row where chord buttons are contained"]






  },
   
  vb:horizontal_aligner {
    mode = "left",
    spacing = 0,
    
    vb:button {
      id = "Hide_Show_Phrases_Column_Button",
      color = {0x60, 0x60, 0x60},
      text = "¤",
      tooltip = "Hide/show the Phrase's column",
      notifier = function()
        if vb.views.Show_Hidden.text == "Shown" then 
         vb.views.Show_Hidden.text = "Hidden"
         vb.views.Hide_Show_Phrases_Column_Button.color = {0x10, 0x90, 0xff}
         vb.views["Phrases_column"].visible = false 
        elseif vb.views.Show_Hidden.text == "Hidden" then
         vb.views.Show_Hidden.text = "Shown"
         vb.views.Hide_Show_Phrases_Column_Button.color = {0x60, 0x60, 0x60}
         vb.views["Phrases_column"].visible = true 
        end
      end
    
    },
    
    vb:text {
      id = "Show_Hidden",
      text = "Shown",
      visible = false 
    }, 
    
    vb:space{
      width = 50
    },  
    
    vb:text{
      text = "Major scale",
      id = "major_scale_button",
      
    
    }, 
    
    vb:popup{
      tooltip = "Choose the scale to apply pitch correction",
      id = "major_scale_popup",
      items = {"C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"}
    },   
    
    vb:popup{
      tooltip = "Decide if the pitch correction will be applied ascending or descending",
      id = "up_or_down_popup_scale",
      items = {"Up", "Down"}
    },  
      
    

    
    vb:space {
      height = 20
    },
    
  }
           
 }
 
 
--- Create all the buttons

local buttons_dictionary = {}
  
if #renoise.song().instruments ~= 0 then 

  for InstrumentIndex = 1, #renoise.song().instruments do 

   if #renoise.song():instrument(InstrumentIndex).phrases ~= 0 then 

    for phrase = 1, #renoise.song():instrument(InstrumentIndex).phrases do
  
      buttons_dictionary["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button {
        id = "Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase),
        color = {0xeb, 0xab, 0x34},
        text = "¤",
        notifier = function()
        end
      }
      
      buttons_dictionary["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)] = vb:text{
        text = "Shown",
        id = "Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)
      }
      
      buttons_dictionary["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(phrase)] = vb:textfield{
        text = "Phrase-"..tostring(phrase),
        width = 59,
        id = "Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(phrase)
      }
    
      if phrase < 10 then vb.views["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(phrase)].text = "Phrase-00"..tostring(phrase)
      elseif phrase < 100 then vb.views["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(phrase)].text = "Phrase-0"..tostring(phrase)
      end
    
      buttons_dictionary["Play_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "Play",
        id = "play_button_"..tostring(InstrumentIndex)..tostring(phrase),
        tooltip = "Play this phrase",
        pressed = function()
        
          write_phrase_into_pattern(InstrumentIndex, phrase)
        
        end
      }
      
      buttons_dictionary["Copy_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "C",
        tooltip = "Copy this phrase's content",
        notifier = function()
          last_phrase_copied = {InstrumentIndex, phrase}
        end
      }
      
      buttons_dictionary["transpose_up"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{                            
        text = "↑",
        tooltip = "Transpose this phrase one semitone up",
        notifier = function()
                          
          transpose_phrase(1, InstrumentIndex, phrase)
                            
        end
      }
                          
      buttons_dictionary["transpose_down"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{             
        text = "↓",
        tooltip = "Transpose this phrase one semitone down",
        notifier = function()
                          
          transpose_phrase(-1, InstrumentIndex, phrase)
                            
        end
      }
          
      buttons_dictionary["Legato_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        color = {0xff, 0xff, 0x00},
        text = "L",
        id = "legato_mode"..tostring(InstrumentIndex)..tostring(phrase),
        tooltip = "Activate the legato mode for this phrase",
        notifier = function()
        
          local legato = "legato_mode"..tostring(InstrumentIndex)..tostring(phrase)
                              
            if legato_is_pushed[legato] == false then 
              vb.views[legato].color = {0xff, 0xff, 0x00} 
              legato_is_pushed[legato] = true
                              
            elseif legato_is_pushed[legato] == nil or legato_is_pushed[legato] == true then 
              vb.views[legato].color = {0, 0, 0}  
              legato_is_pushed[legato] = false
                              
            end  
                                      
        
        end
      }
      
      buttons_dictionary["X_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "X",
        tooltip = "Duplicate the content of this phrase",
        notifier = function()
                          
          local a = renoise.song():instrument(InstrumentIndex):phrase(phrase)
          local sum = a.number_of_lines
                            
          a.number_of_lines = sum * 2
                            
          for i = 1, sum do
                            
            for column = 1, #a:line(1).note_columns do
                              
              a:line(i + sum):note_column(column).note_value = a:line(i):note_column(column).note_value
              a:line(i + sum):note_column(column).volume_value = a:line(i):note_column(column).volume_value
              a:line(i + sum):note_column(column).panning_value = a:line(i):note_column(column).panning_value
              a:line(i + sum):note_column(column).delay_value = a:line(i):note_column(column).delay_value
              a:line(i + sum):note_column(column).effect_number_value = a:line(i):note_column(column).effect_number_value
              a:line(i + sum):note_column(column).effect_amount_value = a:line(i):note_column(column).effect_amount_value  
                                                                                            
            end  
                              
            for column = 1, #a:line(1).effect_columns do
                                
              a:line(i + sum):effect_column(column).number_value = a:line(i):effect_column(column).number_value
              a:line(i + sum):effect_column(column).amount_value = a:line(i):effect_column(column).amount_value   
                                
            end                              
                              
          end  
                          
                          
                          
        end
                          
    }      
      
      buttons_dictionary["Paste_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "P",
        tooltip = "Paste the last content copied into this phrase",
        notifier = function()
          renoise.song():instrument(InstrumentIndex):phrase(phrase):copy_from(renoise.song():instrument(last_phrase_copied[1]):phrase(last_phrase_copied[2]))
        end
     } 
      
      buttons_dictionary["Delete_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "D",
        tooltip = "Delete this phrase's content",
        notifier = function()
          renoise.song().instruments[InstrumentIndex].phrases[phrase]:clear()
        end
      }
            
      buttons_dictionary["Go_Button"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "G",
        tooltip = "Go to this Phrase editor",
        notifier = function()
          renoise.song().selected_instrument_index = InstrumentIndex
          renoise.song().selected_phrase_index = phrase
          renoise.app().window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_PHRASE_EDITOR
          ----now hide the phrase's column:
          vb.views.Hide_Show_Phrases_Column_Button.color = {0x10, 0x90, 0xff}
          vb.views["Phrases_column"].visible = false
          vb.views.Show_Hidden.text = "Hidden"
        
        end
      } 
      
      buttons_dictionary["PC"..tostring(InstrumentIndex)..tostring(phrase)] = vb:button{
        text = "■",
        tooltip = "Apply pitch correction to this phrase, given the selected major scale",
        notifier = function()
          
          Pitch_corrector(InstrumentIndex, phrase)
        
        end
      }
      
                      
      buttons_dictionary["Quant"..tostring(InstrumentIndex)..tostring(phrase)] = vb:popup{
        width = 17,
        tooltip = "Choose the quantization setup per phrase. Parameters are Global quantization, Phrase and No quantization.",
        items = { "G", "P", "N" },
        value = 1,
        id = "quantization_setup_phrase"..tostring(InstrumentIndex)..tostring(phrase)
      }         
          
      
               
               
    end
   end 
  end
end  

-- Create the column that shows the number of track, stop button, and add or delete phrase buttons.

local Number_Of_Track_Column_dictionary = {}

if #renoise.song().instruments ~= 0 then 

  for InstrumentIndex = 1, #renoise.song().instruments do
  
    Number_Of_Track_Column_dictionary["+_button"..tostring(InstrumentIndex)] = vb:button{
      text = "+",
      tooltip = "Add a phrase on this track",
      visible = true,
      notifier = function()
        
        
        local Biggest_Track_phrases_before = BiggestTrackPhrases()---check the current number of phrases for the biggest track.
        renoise.song().instruments[InstrumentIndex]:insert_phrase_at(#renoise.song():instrument(InstrumentIndex).phrases+1)---add the phrase.
        local Biggest_Track_phrases_after = BiggestTrackPhrases()---check if the biggest track changed.
        
        
        local phrase = #renoise.song():instrument(InstrumentIndex).phrases
        
        renoise.song().instruments[InstrumentIndex].phrases[phrase]:clear() ---THIS IS to get rid of the c4 note.
        
        if vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)] == nil then
        ---if phrase does not exist then create the phrase...
          vb:column{
            width = 110,
            style = "panel",
            id = "Phrase Column-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases),
          
    
            vb:column{    
              vb:row{         
                vb:button {
                  id = "Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases),
                  color = {0xeb, 0xab, 0x34},
                  text = "¤",
                  notifier = function()
                  end
                },      
                vb:text{
                  text = "Hidden",
                  id = "Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases),
                  visible = false
                },
                vb:textfield{
                  width = 59,
                  text = "Phrase-"..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1),
                  id = "Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)
                },
                vb:button{
                  text = "Play",
                  id = "play_button_"..tostring(InstrumentIndex)..tostring(phrase),
                  tooltip = "Play this phrase",
                  pressed = function()
                  
                    write_phrase_into_pattern(InstrumentIndex, phrase)
                  
                  end
                }        
              }      
            },
          
            vb:column{
              id = "Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases),
              visible = false,    
              vb:row{      
                vb:button{
                  text = "C",
                  tooltip = "Copy this phrase's content",
                  notifier = function()
                    last_phrase_copied = {InstrumentIndex, phrase}
                  end
                },
                vb:button{                            
                  text = "↑",
                  tooltip = "Transpose this phrase one semitone up",
                  notifier = function()
                          
                    transpose_phrase(1, InstrumentIndex, phrase)
                            
                  end
                },
                          
                vb:button{             
                  text = "↓",
                  tooltip = "Transpose this phrase one semitone down",
                  notifier = function()
                          
                    transpose_phrase(-1, InstrumentIndex, phrase)
                            
                  end
                },    
                vb:button{
                  color = {0xff, 0xff, 0x00},
                  text = "L",
                  id = "legato_mode"..tostring(InstrumentIndex)..tostring(phrase),
                  tooltip = "Activate the legato mode for this phrase",
                  notifier = function()
                  
                    local legato = "legato_mode"..tostring(InstrumentIndex)..tostring(phrase)
                              
                    if legato_is_pushed[legato] == false then 
                      vb.views[legato].color = {0xff, 0xff, 0x00} 
                      legato_is_pushed[legato] = true
                              
                    elseif legato_is_pushed[legato] == nil or legato_is_pushed[legato] == true then 
                      vb.views[legato].color = {0, 0, 0}  
                      legato_is_pushed[legato] = false
                              
                    end  
                  
                  end
                },       
              
                vb:button{
                  text = "X",
                  tooltip = "Duplicate the content of this phrase",
                  notifier = function()
                          
                    local a = renoise.song():instrument(InstrumentIndex):phrase(phrase)
                    local sum = a.number_of_lines
                            
                    a.number_of_lines = sum * 2
                            
                    for i = 1, sum do
                            
                      for column = 1, #a:line(1).note_columns do
                              
                        a:line(i + sum):note_column(column).note_value = a:line(i):note_column(column).note_value
                        a:line(i + sum):note_column(column).volume_value = a:line(i):note_column(column).volume_value
                        a:line(i + sum):note_column(column).panning_value = a:line(i):note_column(column).panning_value
                        a:line(i + sum):note_column(column).delay_value = a:line(i):note_column(column).delay_value
                        a:line(i + sum):note_column(column).effect_number_value = a:line(i):note_column(column).effect_number_value
                        a:line(i + sum):note_column(column).effect_amount_value = a:line(i):note_column(column).effect_amount_value  
                                                                                            
                      end  
                              
                      for column = 1, #a:line(1).effect_columns do
                                
                        a:line(i + sum):effect_column(column).number_value = a:line(i):effect_column(column).number_value
                        a:line(i + sum):effect_column(column).amount_value = a:line(i):effect_column(column).amount_value   
                                
                      end                              
                              
                    end  
                          
                                                    
                  end
                
                }  
                          
              },      
                    
              vb:row{      
                vb:button{
                  text = "P",
                  tooltip = "Paste the last content copied into this phrase",
                  notifier = function()
                     renoise.song():instrument(InstrumentIndex):phrase(phrase):copy_from(renoise.song():instrument(last_phrase_copied[1]):phrase(last_phrase_copied[2]))
                  end
                },
                vb:button{
                  text = "D",
                  tooltip = "Delete this phrase's content",
                  notifier = function()
                    renoise.song().instruments[InstrumentIndex].phrases[phrase]:clear()
                  end
                },
                vb:button{
                  text = "G",
                  tooltip = "Go this Phrase editor",
                  notifier = function()
                    renoise.song().selected_instrument_index = InstrumentIndex
                    renoise.song().selected_phrase_index = phrase
                    renoise.app().window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_PHRASE_EDITOR 
                    ----now hide the phrase's column:
                    vb.views.Hide_Show_Phrases_Column_Button.color = {0x10, 0x90, 0xff}
                    vb.views["Phrases_column"].visible = false 
                    vb.views.Show_Hidden.text = "Hidden"                
                    
                  end
                },
                
                vb:button{
                  text = "■",
                  tooltip = "Apply pitch correction to this phrase, given the selected major scale",
                  notifier = function()
                          
                    Pitch_corrector(InstrumentIndex, phrase)
                          
                  end 
                },
                
                vb:popup{
                  width = 17,
                  tooltip = "Choose the quantization setup per phrase. Parameters are Global quantization, Phrase and No quantization.",
                  items = { "G", "P", "N" },
                  value = 1,
                  id = "quantization_setup_phrase"..tostring(InstrumentIndex)..tostring(phrase)
                }                                 
              }      
            }
      
        } 
        
        if #renoise.song():instrument(InstrumentIndex).phrases < 10 then vb.views["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].text = "Phrase-00"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)
        elseif #renoise.song():instrument(InstrumentIndex).phrases < 100 then vb.views["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].text = "Phrase-0"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)
        end       
        end
        
        
        if vb.views["S/H VAR"].text == "Shown" then
                         
          vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].visible = true 
              
          vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].text = "Shown"
                
          vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].color = {0xeb, 0xab, 0x34} 
                          
        end     
        
        if vb.views["S/H VAR"].text == "Hidden" then    
          
          vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].visible = false
          
          vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].text = "Hidden"
          
          vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].color = {0x60, 0x60, 0x60}
          
          end 
          
          renoise.song():instrument(InstrumentIndex):phrase(phrase).number_of_lines = tonumber(vb.views["LPP_Button"].text) 
          renoise.song():instrument(InstrumentIndex):phrase(phrase).lpb = tonumber(vb.views["LPB_Button"].text) 
                
              
        
        ---Now, there are two situation when we need to update the GUI. One is when we are in the last page of a track and the phrases do not make for the 10 phrase limit. The other case is when we are after the last page of a track that filled all the 10 phrases limit.
        
        local IsRouteB = nil
        local IsRouteA = nil
        local constant = Number_of_phrases_per_page - 1
        local Number_Of_Pages_For_This_Track = #renoise.song():instrument(InstrumentIndex).phrases - constant
        if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
        
        local array = {} 
        for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
        table.insert(array, column)
       
        end
        
        local IsColumn --- we need to write this code in order to find the number of column (1 to 10) where we are going to place our phrase.
        for i = 1, #array do
          if InstrumentIndex == array[i] then 
            IsColumn = i
            break
          end
        end    
        
        for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(InstrumentIndex)-1 do
          
          ---this is route A:
          if tonumber(vb.views["Page_among_phrases_text"].text) == page and Limit_values_For_Phrases(InstrumentIndex)[page][2] <= Number_of_phrases_per_page + page - 1 then
            
            vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(tostring(#renoise.song():instrument(InstrumentIndex).phrases))]) 
            IsRouteA = true  
            print("route A")                
            break
          end
        end    
        
        ---this is route B:  
        if tonumber(vb.views["Page_among_phrases_text"].text) == #Limit_values_For_Phrases(InstrumentIndex) then
            vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["space"..tostring(InstrumentIndex)])
            vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(tostring(#renoise.song():instrument(InstrumentIndex).phrases))]) 
            IsRouteA = false 
            IsRouteB = true
            print("route B")                   
        end
        
        ---So far we're good. The last thing we need to do is to update the master track.. if needed.
        
        if Biggest_Track_phrases_after - Biggest_Track_phrases_before == 1 then
          if vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)] == nil then
            vb:column{
              id = "Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases),        
              vb:button{
                text = "Play-"..tostring(#renoise.song():instrument(InstrumentIndex).phrases),
                id = "Play Button from master"..tostring(#renoise.song():instrument(InstrumentIndex).phrases),
                pressed = function()
                  
                  play_button_for_master(phrase)
                  
                end  
                  
              }              
            }
          end  
      
          if #renoise.song():instrument(InstrumentIndex).phrases < 10 then vb.views["Play Button from master"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].text = "Play-00"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)   
          elseif #renoise.song():instrument(InstrumentIndex).phrases < 100 then vb.views["Play Button from master"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)].text = "Play-0"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)
          end
          ---
        
          if IsRouteA == true then
            
            vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)])
          
          end
          
          if IsRouteB == true and #renoise.song():instrument(InstrumentIndex).phrases == 1 then
          
            vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases)])
            
          end    
          
        end  
          
           
             
        
        
      end
    }
  
    Number_Of_Track_Column_dictionary["-_button"..tostring(InstrumentIndex)] = vb:button{
      text = "-",
      tooltip = "Delete a phrase on this track",
      visible = true,
      notifier = function()
        if #renoise.song():instrument(InstrumentIndex).phrases > 0 then 
          local routeA  
          local numberOfPhrases_avant = #renoise.song():instrument(InstrumentIndex).phrases---check the number of phrases in this track before deleting the last phrase.
          local Biggest_Track_phrases_before = BiggestTrackPhrases()---check the current number of phrases for the biggest track.
          
          
          renoise.song().instruments[InstrumentIndex]:delete_phrase_at(#renoise.song():instrument(InstrumentIndex).phrases)--delete the last phrase.
          
          local numberOfPhrases_apres = #renoise.song():instrument(InstrumentIndex).phrases---check the number of phrases in this track after deleting the last phrase.
          local Biggest_Track_phrases_after = BiggestTrackPhrases()---check if the biggest track changed.
          local IsSpaceNeeded = nil
          
                       
        
        ---Now, there are two situation when we need to update the GUI. Route A represents the situation where there are zero phrases because we just deleted the first and only phrase and thus we'll need to agregate an space to not collapse the view. Route B is when there are still phrases in the view, even after deleting the last phrase.
        
          ---local IsRouteB = nil
          local constant = Number_of_phrases_per_page - 1
          local Number_Of_Pages_For_This_Track = #renoise.song():instrument(InstrumentIndex).phrases - constant +1
          if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
          
          local array2 = {} 
          for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
          table.insert(array2, column)
       
          end
        
          local IsColumn --- we need to write this code in order to find the number of column (1 to 10) where we are going to place our phrase.
          for i = 1, #array2 do
            if InstrumentIndex == array2[i] then 
              IsColumn = i
              break
            end
          end              
          
          ---this is route A
          if (Limit_values_For_Phrases(InstrumentIndex) == nil and numberOfPhrases_avant-numberOfPhrases_apres == 1) and tonumber(vb.views["Page_among_phrases_text"].text) == 1 then
            vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(1)]) 
            if vb.views["space"..tostring(InstrumentIndex)] == nil then            
              vb:space{width = 110, id = "space"..tostring(InstrumentIndex)} 
            end 
            vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["space"..tostring(InstrumentIndex)])
            routeA = true
          end  
          
          ---this is route B:
          if Limit_values_For_Phrases(InstrumentIndex) ~= nil then
            
            for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(InstrumentIndex)+1 do
          
              if tonumber(vb.views["Page_among_phrases_text"].text) == page then
                
               --- IsRouteB = true
            
            
                vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)]) 
     
        
                if Limit_values_For_Phrases(InstrumentIndex)[tonumber(vb.views["Page_among_phrases_text"].text)] == nil  then
          
                  if vb.views["space"..tostring(InstrumentIndex)] == nil then            
                  vb:space{width = 110, id = "space"..tostring(InstrumentIndex)} 
                  end 
        
                  vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["space"..tostring(InstrumentIndex)])
       
                end  
                
              
              end  
              
            end
          end    
            
            ---Now lets make some code in case we are at the last page with only one phrase. In that case we'll need to update all the tracks and change the page.
            if Limit_values_For_Phrases(InstrumentIndex) ~= nil then
             
             
              if Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 and #Limit_values_For_Phrases(InstrumentIndex)+1 == tonumber(vb.views["Page_among_phrases_text"].text)  then---if we'll need to update the master column and we are also in the last page of the track...
                
              
                ---print("hi")
                
                vb.views["Page_among_phrases_text"].text = tostring(tonumber(vb.views["Page_among_phrases_text"].text)-1)
                
                local array = {}
                for i = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                table.insert(array, i)
       
                end
       
                for i = 1, #array do
       
                  ---lets remove the content first for each given track.
                  if Limit_values_For_Phrases(array[i]) == nil or tonumber(Page_among_phrases_text.text)+1 > #Limit_values_For_Phrases(array[i]) then
                    if vb.views["space"..tostring(array[i])] ~= nil then   
                      vb.views["column-"..tostring(i)]:remove_child(vb.views["space"..tostring(array[i])])
                    end            
         
                  else
                    for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)+(1)][1], Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)+(1)][2] do                                        
                      vb.views["column-"..tostring(i)]:remove_child(vb.views["Phrase Column-"..tostring(array[i])..tostring(phrase)])
                    end
                     
                  end  
         
                  ---now lets add new content for the new page.
                  if Limit_values_For_Phrases(array[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[i]) then 
                    if vb.views["space"..tostring(array[i])] == nil then
                      vb:space{width = 110, id = "space"..tostring(array[i])}
                    end  
                      
                    vb.views["column-"..tostring(i)]:add_child(vb.views["space"..tostring(array[i])]) 
                      
         
                  else
                  

                    for phrase = Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)][2] do                                        
                      vb.views["column-"..tostring(i)]:add_child(vb.views["Phrase Column-"..tostring(array[i])..tostring(phrase)])
                    end
                     
                     
                  end   
         
         
           
         
         
                end
       
                if limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)] ~= nil then
                  for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][2] do
                    vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
                  end
                end  
       
                if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
                  for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
                    if vb.views["Master Column dictionary"..tostring(master)] == nil then
                      MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
                        id = "Master Column dictionary"..tostring(master),
        
                        vb:button{
                        text = "Play-"..tostring(master),
                        id = "Play Button from master"..tostring(master)

                        }             
                      }
                    end    
                    vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
                  end
                end 
                
                vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)]) 
                 
         
             
             else
             
               for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(InstrumentIndex)+1 do
          
                 if tonumber(vb.views["Page_among_phrases_text"].text) == page and Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 then 
                   vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)])       
                 
                 end    
               end
             end 
             
           end 
    
      
            
            if routeA == true then ---if we need to update the master column and we just deleted the first and only phrase of the track.
              if Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 then
                vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)])
              end  
            end
              
              
                  
             
           
        end
        
        vb.views["play_button_"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
        vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
        vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
        vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
        vb.views["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
        vb.views["legato_mode"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
        vb.views["quantization_setup_phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil         
        vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
      
      end
        
      
    }
  
    Number_Of_Track_Column_dictionary["Stop_button"..tostring(InstrumentIndex)] = vb:button{
      text = "S",
      tooltip = "Stop this track",
      notifier = function()
      
        if instrument_playback_position_start[tostring(InstrumentIndex)] ~= nil then ---if this track has already been played:
          local phrase = instrument_playback_position_start[tostring(InstrumentIndex)][3]
                
          if is_pushed[tostring(InstrumentIndex)..tostring(phrase)] == true then ---if the phrase is pushed.
                    
            is_pushed[tostring(InstrumentIndex)..tostring(phrase)] = false
            vb.views["play_button_"..tostring(InstrumentIndex)..tostring(phrase)].color = {0,0,0}
                
            if renoise.song().transport.playing == true then
                    
              local current_sequence = renoise.song().transport.edit_pos.sequence
              local current_line = renoise.song().transport.edit_pos.line
              local line = renoise.song():pattern(current_sequence):track(InstrumentIndex):line(current_line+1):note_column(1)
                                          
              line.note_value = 120 
       
              line.instrument_value = InstrumentIndex-1 
                      
            end
                    
          end
                  
        end      
                 
        
      end
    }
  
    Number_Of_Track_Column_dictionary["Track_Number_text"..tostring(InstrumentIndex)] = vb:textfield{
      text = "Track-"..tostring(InstrumentIndex),
      id = "Track_Number_text"..tostring(InstrumentIndex) 
    }
  
    if  InstrumentIndex < 10 then vb.views["Track_Number_text"..tostring(InstrumentIndex)].text = "Track-00"..tostring(InstrumentIndex)
    elseif InstrumentIndex < 100 then vb.views["Track_Number_text"..tostring(InstrumentIndex)].text = "Track-0"..tostring(InstrumentIndex)
    end
 
  end
  
end   

---create the row where the rotary and its options are contained:
       
    
--Create the column that contains the stop phrase button, add and delete buttons and track number text.

if #renoise.song().instruments ~= 0 then 

  for InstrumentIndex = 1, #renoise.song().instruments do
  
    Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)] = vb:column{
      width = 110,
      style = "group",
      id = "Superior Column-"..tostring(InstrumentIndex),
      
      create_rotary_column(InstrumentIndex),
      
      vb:row{
    
        Number_Of_Track_Column_dictionary["+_button"..tostring(InstrumentIndex)],
        Number_Of_Track_Column_dictionary["-_button"..tostring(InstrumentIndex)]
      
      },
    
      vb:row{
    
        Number_Of_Track_Column_dictionary["Track_Number_text"..tostring(InstrumentIndex)],
        Number_Of_Track_Column_dictionary["Stop_button"..tostring(InstrumentIndex)]
      
      }
    
    }
  
  end
  
end   

---Create the superior column of a phrase column

local Superior_Column_Of_Phrase_dictionary = {}

if #renoise.song().instruments ~= 0 then

  for InstrumentIndex = 1, #renoise.song().instruments do
  
    if #renoise.song():instrument(InstrumentIndex).phrases ~= 0 then 

      for phrase = 1, #renoise.song():instrument(InstrumentIndex).phrases do
  
  
        Superior_Column_Of_Phrase_dictionary["Superior Column Of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)] = vb:column{
    
          vb:row{
          
            buttons_dictionary["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["Play_Button"..tostring(InstrumentIndex)..tostring(phrase)]
        
          }
      
        }
    
      end
      
    end  
  
  end 
  
end  

---Create the options column

local Options_Column_dictionary = {}

if #renoise.song().instruments ~= 0 then

  for InstrumentIndex = 1, #renoise.song().instruments do
  
    if #renoise.song():instrument(InstrumentIndex).phrases ~= 0 then

      for phrase = 1, #renoise.song():instrument(InstrumentIndex).phrases do
  
        Options_Column_dictionary["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)] = vb:column{
          id = "Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase),
          vb:row{
      
            buttons_dictionary["Copy_Button"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["transpose_up"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["transpose_down"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["Legato_Button"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["X_Button"..tostring(InstrumentIndex)..tostring(phrase)]
        
          },
      
          vb:row{
      
            buttons_dictionary["Paste_Button"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["Delete_Button"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["Go_Button"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["PC"..tostring(InstrumentIndex)..tostring(phrase)],
            buttons_dictionary["Quant"..tostring(InstrumentIndex)..tostring(phrase)]
        
          }
      
        }
      
      end  
    
    end
  
  end
  
end  

---Create each Phrase Column

local Phrase_Column_dictionary = {}

  for InstrumentIndex = 1, #renoise.song().instruments do
  
    if #renoise.song():instrument(InstrumentIndex).phrases ~= 0 then

      for phrase = 1, #renoise.song():instrument(InstrumentIndex).phrases do
  
        Phrase_Column_dictionary["Phrase Column-"..tostring(InstrumentIndex)..tostring(phrase)] = vb:column{
          width = 110,
          style = "panel",
          id = "Phrase Column-"..tostring(InstrumentIndex)..tostring(phrase),
          
    
          Superior_Column_Of_Phrase_dictionary["Superior Column Of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)],
          Options_Column_dictionary["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)]
      
        }
         
        
        
        
        
      
      end  
        
    end   
    
   
  end
          

        
---Create the All Tracks row and the 10 columns that will represent the tracks.

local All_Tracks_Row = vb:row{spacing = 5}
local Eight_Tracks_Columns_dictionary = {}

for InstrumentIndex = 1, Number_of_tracks_per_page do
  
  Eight_Tracks_Columns_dictionary["column-"..tostring(InstrumentIndex)] = vb:column{id = "column-"..tostring(InstrumentIndex)}
  
  
  All_Tracks_Row:add_child(Eight_Tracks_Columns_dictionary["column-"..tostring(InstrumentIndex)])
    
  
end 

---Add the phrases to each track column. We are creating the first page of the view.
local IsPhraseEmpty 
for InstrumentIndex = 1, Number_of_tracks_per_page do
  IsPhraseEmpty = nil

  for phrase = 1, Number_of_phrases_per_page do
  
    if vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(phrase)] ~= nil then 

      Eight_Tracks_Columns_dictionary["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(phrase)])
      
      IsPhraseEmpty = false
      
    else 
    
      if IsPhraseEmpty == false then break
      
      else
    
        Eight_Tracks_Columns_dictionary["column-"..tostring(InstrumentIndex)]:add_child(vb:space{width = 110, id = "space"..tostring(InstrumentIndex)}) 
        break 
      end  
    
    end
  
  end
  
end  
  
---Create the row that contains all the superior part of the track columns. I mean, the one with the track name, stop and add or delete buttons.

  local All_Superior_Tracks_Row = vb:row{id = "All_Superior_Tracks_Row", spacing = 6}

--Add the superior columns to the view. This is for the first page.

  for InstrumentIndex = 1, Number_of_tracks_per_page do
  
    if Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)] ~= nil then  
      All_Superior_Tracks_Row:add_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
    else break        
    end
    
  end           
      
--- Create the master column.       

  local MasterColumn = vb:column{spacing = 36, id = "MasterColumn"}
  
--- Create all the columns for the MasterColumn.

  local MasterColumns_dictionary = {}    
    for column = 1, BiggestTrackPhrases() do
    
      MasterColumns_dictionary["Master Column dictionary"..tostring(column)] = vb:column{
        id = "Master Column dictionary"..tostring(column),
        
        vb:button{
          text = "Play-"..tostring(column),
          id = "Play Button from master"..tostring(column),
          pressed = function()
            play_button_for_master(column)
          end  
        }        
      
      }
      
      if column < 10 then vb.views["Play Button from master"..tostring(column)].text = "Play-00"..tostring(column)   
      elseif column < 100 then vb.views["Play Button from master"..tostring(column)].text = "Play-0"..tostring(column)
      end
       
    end
        
--- Create the first 8 Master Columns for the first page.
  for phrase = 1, Number_of_phrases_per_page do
  
    if MasterColumns_dictionary["Master Column dictionary"..tostring(phrase)] ~= nil then
  
      MasterColumn:add_child(MasterColumns_dictionary["Master Column dictionary"..tostring(phrase)])
      
    end  
    
  end            
      
 ---Create the show and hide buttons for the option columns.
 vb:text{text = "Shown", id = "S/H VAR"}
 local Show_Or_Hide_Options_Phrases_button = vb:button{
 
   text = "S/H",
   id = "S/H",
   color = {0xeb, 0xab, 0x34},
   tooltip = "Show or hide all the phrase's option columns",
   notifier = function()
     for InstrumentIndex = 1, #renoise.song().instruments do     
       for phrase = 1, #renoise.song():instrument(InstrumentIndex).phrases do
       
         if vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text == "Hidden" then
           
           vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text = "Shown"
           vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase)].color = {0xeb, 0xab, 0x34}
           vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)].visible = true
           vb.views["S/H VAR"].text = "Shown"
           vb.views["S/H"].color = {0xeb, 0xab, 0x34}
           
           
           MasterColumn.spacing = 36
           
         elseif vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text == "Shown" then
           
           vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text = "Hidden"
           vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase)].color = {0x60, 0x60, 0x60}
           vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)].visible = false
           vb.views["S/H VAR"].text = "Hidden"
           vb.views["S/H"].color = {0x60, 0x60, 0x60}
           
           MasterColumn.spacing = 0  
           
         end
       end
     end
   end
 }  
 
                     
---Create buttons to move through the tracks


  local Move_Right_Through_Tracks_Button = vb:button{
    tooltip = "Move through the tracks",
    text = ">",
    notifier = function()
      local constant = Number_of_tracks_per_page - 1
      local Number_Of_Pages_For_This_Track = #renoise.song().instruments - constant ---get the number of pages for the tracks, aka the superior track column.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
      
      if tonumber(Page_among_tracks_text.text) < Number_Of_Pages_For_This_Track then 
        Page_among_tracks_text.text = tostring(tonumber(Page_among_tracks_text.text) + 1)        
      
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) - 1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) - 1][2] do  
      
          All_Superior_Tracks_Row:remove_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
          
        end
        
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
          All_Superior_Tracks_Row:add_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
        end 
        
        ----now lets change the phrase columns to reflect the changes.
        
        local array_remove = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)-1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)-1][2] do 
        table.insert(array_remove, InstrumentIndex)
       
        end
        
        local array_add = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
        table.insert(array_add, InstrumentIndex)
       
        end
       
        for InstrumentIndex = 1, #array_remove do
       
         ---lets remove the content first for each given track.
          if Limit_values_For_Phrases(array_remove[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_remove[InstrumentIndex]) then
            if vb.views["space"..tostring(array_remove[InstrumentIndex])] ~= nil then   
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array_remove[InstrumentIndex])])
            end            
         
          else
            for phrase = Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array_remove[InstrumentIndex])..tostring(phrase)])
            end
                     
          end  
        end
        
        for InstrumentIndex = 1, #array_add do  
         
          ---now lets add new content for the new page.
          if Limit_values_For_Phrases(array_add[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_add[InstrumentIndex]) then 
            if vb.views["space"..tostring(array_add[InstrumentIndex])] == nil then
              vb:space{width = 110, id = "space"..tostring(array_add[InstrumentIndex])}
            end  
               
            vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array_add[InstrumentIndex])]) 
         
          else

            for phrase = Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array_add[InstrumentIndex])..tostring(phrase)])
            end
                     
          end
          
        end           
          
      end            
           
    end
  }
  
  local Move_left_Through_Tracks_Button = vb:button{
    tooltip = "Move through the tracks",
    text = "<",
    notifier = function()
    
      local constant = Number_of_tracks_per_page - 1
      local Number_Of_Pages_For_This_Track = #renoise.song().instruments - constant ---get the number of pages for the tracks, aka the superior track column.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
      
      if tonumber(Page_among_tracks_text.text) > 1 then 
        Page_among_tracks_text.text = tostring(tonumber(Page_among_tracks_text.text) - 1)        
      
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) + 1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) + 1][2] do  
      
          All_Superior_Tracks_Row:remove_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
          
        end
        
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
          All_Superior_Tracks_Row:add_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
        end 
        
        ----now lets change the phrase columns to reflect the changes.
        
        local array_remove = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)+1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)+1][2] do 
        table.insert(array_remove, InstrumentIndex)
       
        end
        
        local array_add = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
        table.insert(array_add, InstrumentIndex)
       
        end
       
        for InstrumentIndex = 1, #array_remove do
       
         ---lets remove the content first for each given track.
          if Limit_values_For_Phrases(array_remove[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_remove[InstrumentIndex]) then
            if vb.views["space"..tostring(array_remove[InstrumentIndex])] ~= nil then   
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array_remove[InstrumentIndex])])
            end            
         
          else
            for phrase = Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array_remove[InstrumentIndex])..tostring(phrase)])
            end
                     
          end  
        end
        
        for InstrumentIndex = 1, #array_add do  
         
          ---now lets add new content for the new page.
          if Limit_values_For_Phrases(array_add[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_add[InstrumentIndex]) then 
            if vb.views["space"..tostring(array_add[InstrumentIndex])] == nil then
              vb:space{width = 110, id = "space"..tostring(array_add[InstrumentIndex])}
            end  
               
            vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array_add[InstrumentIndex])]) 
         
          else

            for phrase = Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array_add[InstrumentIndex])..tostring(phrase)])
            end
                     
          end
          
        end           
          
      end 
    
    end
  }


  
  local Button_to_move_across_tracks_Row = vb:row{
    Move_left_Through_Tracks_Button,
    Page_among_tracks_text,
    Move_Right_Through_Tracks_Button
  } 

---Create buttons to move through the phrases
  
  local Move_Up_Through_Phrases_Button = vb:button{
    tooltip = "Move through the phrases",
    text = "└",
    notifier = function()
      local constant = Number_of_phrases_per_page - 1
      local Number_Of_Pages_For_This_Track = BiggestTrackPhrases() - constant ---get the number of pages for the biggest track.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
     
      if tonumber(Page_among_phrases_text.text) > 1 then 
       Page_among_phrases_text.text = tostring(tonumber(Page_among_phrases_text.text) - 1)
       
   
       local array = {}
       for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
       table.insert(array, InstrumentIndex)
       
       end
       
       for InstrumentIndex = 1, #array do
       
         ---lets remove the content first for each given track.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text)+1 > #Limit_values_For_Phrases(array[InstrumentIndex]) then
           if vb.views["space"..tostring(array[InstrumentIndex])] ~= nil then   
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array[InstrumentIndex])])
           end            
         
         else
           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)+(1)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)+(1)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end  
         
         ---now lets add new content for the new page.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[InstrumentIndex]) then 
           if vb.views["space"..tostring(array[InstrumentIndex])] == nil then
             vb:space{width = 110, id = "space"..tostring(array[InstrumentIndex])}
           end  
               
           vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array[InstrumentIndex])]) 
         
         else

           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end   
         
         
           
         
         
       end
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)] ~= nil then
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][2] do
           vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
           if vb.views["Master Column dictionary"..tostring(master)] == nil then
             MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
               id = "Master Column dictionary"..tostring(master),
        
               vb:button{
               text = "Play-"..tostring(master),
               id = "Play Button from master"..tostring(master)
               }             
             }
           end    
           vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
         
      end
      
    end      
      
  }
  
    local Move_Down_Through_Phrases_Button = vb:button{
    tooltip = "Move through the phrases",
    text = "┐",
    notifier = function()
     if tonumber(vb.views["Page_among_phrases_text"].text) < BiggestTrackPhrases() then      
      local constant = Number_of_phrases_per_page - 1
      local Number_Of_Pages_For_This_Track = BiggestTrackPhrases() - constant ---get the number of pages for the biggest track.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
     
      if tonumber(Page_among_phrases_text.text) < (Number_Of_Pages_For_This_Track+Number_of_phrases_per_page-1) and BiggestTrackPhrases() > 0  then 
       Page_among_phrases_text.text = tostring(tonumber(Page_among_phrases_text.text) + 1)
       
       local array = {}
       for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
       table.insert(array, InstrumentIndex)
       
       end
       
       for InstrumentIndex = 1, #array do
       
         ---lets remove the content first for each given track.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text)-1 > #Limit_values_For_Phrases(array[InstrumentIndex]) then
           if vb.views["space"..tostring(array[InstrumentIndex])] ~= nil then   
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array[InstrumentIndex])])
           end            
         
         else
           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)-(1)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)-(1)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end  
         
         ---now lets add new content for the new page.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[InstrumentIndex]) then 
           if vb.views["space"..tostring(array[InstrumentIndex])] == nil then
             vb:space{width = 110, id = "space"..tostring(array[InstrumentIndex])}
           end  
               
           vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array[InstrumentIndex])]) 
         
         else

           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end   
         
         
           
         
         
       end
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)-(1)] ~= nil then
       
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)-(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)-(1)][2] do
           vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
         
       end  
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
           if vb.views["Master Column dictionary"..tostring(master)] == nil then
             MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
               id = "Master Column dictionary"..tostring(master),
        
               vb:button{
               text = "Play-"..tostring(master),
               id = "Play Button from master"..tostring(master)
               }             
             }
           end    
           vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
         
      end
     end   
    end    
   
  }  
  
  ---Key handler.
  
  local function key_handler(dialog, key)
  
    if (key.name == "x") then ---key handler for "x" key.
     if tonumber(vb.views["Page_among_phrases_text"].text) < BiggestTrackPhrases() then
      local constant = Number_of_phrases_per_page - 1
      local Number_Of_Pages_For_This_Track = BiggestTrackPhrases() - constant ---get the number of pages for the biggest track.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
     
      if tonumber(Page_among_phrases_text.text) < (Number_Of_Pages_For_This_Track+Number_of_phrases_per_page-1) and BiggestTrackPhrases() > 0 then 
       Page_among_phrases_text.text = tostring(tonumber(Page_among_phrases_text.text) + 1)
       
       local array = {}
       for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
       table.insert(array, InstrumentIndex)
       
       end
       
       for InstrumentIndex = 1, #array do
       
         ---lets remove the content first for each given track.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text)-1 > #Limit_values_For_Phrases(array[InstrumentIndex]) then
           if vb.views["space"..tostring(array[InstrumentIndex])] ~= nil then   
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array[InstrumentIndex])])
           end            
         
         else
           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)-(1)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)-(1)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end  
         
         ---now lets add new content for the new page.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[InstrumentIndex]) then 
           if vb.views["space"..tostring(array[InstrumentIndex])] == nil then
             vb:space{width = 110, id = "space"..tostring(array[InstrumentIndex])}
           end  
               
           vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array[InstrumentIndex])]) 
         
         else

           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end   
         
         
           
         
         
       end
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)-(1)] ~= nil then
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)-(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)-(1)][2] do
           vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
           if vb.views["Master Column dictionary"..tostring(master)] == nil then
             MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
               id = "Master Column dictionary"..tostring(master),
        
               vb:button{
               text = "Play-"..tostring(master),
               id = "Play Button from master"..tostring(master)
               }             
             }
           end    
           vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
         
      end
     end    
    end
      
    
    if (key.name == "s") then ---key handler for "s" key.
      local constant = Number_of_phrases_per_page - 1
      local Number_Of_Pages_For_This_Track = BiggestTrackPhrases() - constant ---get the number of pages for the biggest track.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
     
      if tonumber(Page_among_phrases_text.text) > 1 then 
       Page_among_phrases_text.text = tostring(tonumber(Page_among_phrases_text.text) - 1)
       
   
       local array = {}
       for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
       table.insert(array, InstrumentIndex)
       
       end
       
       for InstrumentIndex = 1, #array do
       
         ---lets remove the content first for each given track.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text)+1 > #Limit_values_For_Phrases(array[InstrumentIndex]) then
           if vb.views["space"..tostring(array[InstrumentIndex])] ~= nil then   
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array[InstrumentIndex])])
           end            
         
         else
           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)+(1)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)+(1)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end  
         
         ---now lets add new content for the new page.
         if Limit_values_For_Phrases(array[InstrumentIndex]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[InstrumentIndex]) then 
           if vb.views["space"..tostring(array[InstrumentIndex])] == nil then
             vb:space{width = 110, id = "space"..tostring(array[InstrumentIndex])}
           end  
               
           vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array[InstrumentIndex])]) 
         
         else

           for phrase = Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[InstrumentIndex])[tonumber(Page_among_phrases_text.text)][2] do                                        
             vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array[InstrumentIndex])..tostring(phrase)])
           end
                     
         end   
         
         
           
         
         
       end
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)] ~= nil then
       
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][2] do
           vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
       
       if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
         for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
           if vb.views["Master Column dictionary"..tostring(master)] == nil then
             MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
               id = "Master Column dictionary"..tostring(master),
        
               vb:button{
               text = "Play-"..tostring(master),
               id = "Play Button from master"..tostring(master)
               }             
             }
           end    
           vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
         end
       end  
         
      end
    end 
    
    if (key.name == "d") then ---key handler for "d" key.
    
      local constant = Number_of_tracks_per_page - 1
      local Number_Of_Pages_For_This_Track = #renoise.song().instruments - constant ---get the number of pages for the tracks, aka the superior track column.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
      
      if tonumber(Page_among_tracks_text.text) < Number_Of_Pages_For_This_Track then 
        Page_among_tracks_text.text = tostring(tonumber(Page_among_tracks_text.text) + 1)        
      
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) - 1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) - 1][2] do  
      
          All_Superior_Tracks_Row:remove_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
          
        end
        
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
          All_Superior_Tracks_Row:add_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
        end 
        
        ----now lets change the phrase columns to reflect the changes.
        
        local array_remove = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)-1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)-1][2] do 
        table.insert(array_remove, InstrumentIndex)
       
        end
        
        local array_add = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
        table.insert(array_add, InstrumentIndex)
       
        end
       
        for InstrumentIndex = 1, #array_remove do
       
         ---lets remove the content first for each given track.
          if Limit_values_For_Phrases(array_remove[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_remove[InstrumentIndex]) then
            if vb.views["space"..tostring(array_remove[InstrumentIndex])] ~= nil then   
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array_remove[InstrumentIndex])])
            end            
         
          else
            for phrase = Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array_remove[InstrumentIndex])..tostring(phrase)])
            end
                     
          end  
        end
        
        for InstrumentIndex = 1, #array_add do  
         
          ---now lets add new content for the new page.
          if Limit_values_For_Phrases(array_add[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_add[InstrumentIndex]) then 
            if vb.views["space"..tostring(array_add[InstrumentIndex])] == nil then
              vb:space{width = 110, id = "space"..tostring(array_add[InstrumentIndex])}
            end  
               
            vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array_add[InstrumentIndex])]) 
         
          else

            for phrase = Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array_add[InstrumentIndex])..tostring(phrase)])
            end
                     
          end
          
        end           
          
      end 
    end       
    
    if (key.name == "a") then ---key handler for "a" key.
      
      local constant = Number_of_tracks_per_page - 1
      local Number_Of_Pages_For_This_Track = #renoise.song().instruments - constant ---get the number of pages for the tracks, aka the superior track column.
      if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
      
      if tonumber(Page_among_tracks_text.text) > 1 then 
        Page_among_tracks_text.text = tostring(tonumber(Page_among_tracks_text.text) - 1)        
      
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) + 1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text) + 1][2] do  
      
          All_Superior_Tracks_Row:remove_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
          
        end
        
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
          All_Superior_Tracks_Row:add_child(Superior_Column_dictionary["Superior Column-"..tostring(InstrumentIndex)])
        end 
        
        ----now lets change the phrase columns to reflect the changes.
        
        local array_remove = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)+1][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)+1][2] do 
        table.insert(array_remove, InstrumentIndex)
       
        end
        
        local array_add = {}
        for InstrumentIndex = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
        table.insert(array_add, InstrumentIndex)
       
        end
       
        for InstrumentIndex = 1, #array_remove do
       
         ---lets remove the content first for each given track.
          if Limit_values_For_Phrases(array_remove[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_remove[InstrumentIndex]) then
            if vb.views["space"..tostring(array_remove[InstrumentIndex])] ~= nil then   
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["space"..tostring(array_remove[InstrumentIndex])])
            end            
         
          else
            for phrase = Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_remove[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:remove_child(vb.views["Phrase Column-"..tostring(array_remove[InstrumentIndex])..tostring(phrase)])
            end
                     
          end  
        end
        
        for InstrumentIndex = 1, #array_add do  
         
          ---now lets add new content for the new page.
          if Limit_values_For_Phrases(array_add[InstrumentIndex]) == nil or tonumber(vb.views["Page_among_phrases_text"].text) > #Limit_values_For_Phrases(array_add[InstrumentIndex]) then 
            if vb.views["space"..tostring(array_add[InstrumentIndex])] == nil then
              vb:space{width = 110, id = "space"..tostring(array_add[InstrumentIndex])}
            end  
               
            vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["space"..tostring(array_add[InstrumentIndex])]) 
         
          else

            for phrase = Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][1], Limit_values_For_Phrases(array_add[InstrumentIndex])[tonumber(vb.views["Page_among_phrases_text"].text)][2] do                                        
              vb.views["column-"..tostring(InstrumentIndex)]:add_child(vb.views["Phrase Column-"..tostring(array_add[InstrumentIndex])..tostring(phrase)])
            end
                     
          end
          
        end           
          
      end 
    end
    
    if (key.name == "q") then ---key handler for "q" key.
    
      for InstrumentIndex = 1, #renoise.song().instruments do     
       for phrase = 1, #renoise.song():instrument(InstrumentIndex).phrases do
       
         if vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text == "Hidden" then
           
           vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text = "Shown"
           vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase)].color = {0x90, 0x70, 0x70}
           vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)].visible = true
           MasterColumn.spacing = 36
           vb.views["S/H VAR"].text = "Shown"
           vb.views["S/H"].color = {0x90, 0x70, 0x70}
           
         elseif vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text == "Shown" then
           
           vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(phrase)].text = "Hidden"
           vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(phrase)].color = {0x60, 0x60, 0x60}
           vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(phrase)].visible = false
           MasterColumn.spacing = 0 
           vb.views["S/H VAR"].text = "Hidden"
           vb.views["S/H"].color = {0x60, 0x60, 0x60} 
           
         end
       end
     end
     
    end  
    
    if (key.name == "space") then --- key handler for "space" key to stop playback.
      
      if renoise.song().transport.playing == true then
        vb.views["start_playing_button"].color = {0, 0, 0}
        renoise.song().transport:stop()
        if vb.views["my_text"].text == "Practice" then
          for i = 1, #renoise.song().patterns do
            renoise.song():pattern(i):clear()
          end 
        end  
        
        for instrument = 1, #renoise.song().instruments do
         -- there_are_phrases_playing_in_this_track[instrument] = false
          sequence_of_phrases_played_in_this_track[instrument] = nil
        end
          
      else ---if playback is not playing then... 
      
        vb.views["start_playing_button"].color = {0xb7, 0xd5, 0xac}
        
        ----if there are phrases playing, then write them in the edit pattern.
        
        local current_sequence = renoise.song().transport.edit_pos.sequence
        local current_line = renoise.song().transport.edit_pos.line
        if vb.views["my_text"].text == "Practice" then
          current_sequence = 1
          current_line = 1
        end  
        
        for instrument = 1, #renoise.song().instruments do
        
          
          for phrase = 1, #renoise.song():instrument(instrument).phrases do
            
            if is_pushed[tostring(instrument)..tostring(phrase)] == true then
              
              if renoise.song():track(instrument).visible_effect_columns < 2 then 
                renoise.song():track(instrument).visible_effect_columns = 2 
              end 
              
               
              local a = renoise.song():pattern(current_sequence):track(instrument):line(current_line) 
       
              a:note_column(1).note_value = 48
       
              a:effect_column(2).number_string = "0Z"    
       
              a:effect_column(2).amount_value = phrase
       
              a:note_column(1).instrument_value = instrument-1
              
              there_are_phrases_playing_in_this_track[instrument] = true
              sequence_of_phrases_played_in_this_track[instrument] = {{phrase, renoise.song():instrument(instrument):phrase(phrase).number_of_lines, current_sequence, current_line }} 
                
              break 
              
              --instrument_playback_position_start[tostring(instrument)] = {1, 1, phrase} 
       
            end
            
          end  
          
        
                        
         end
       
         
         renoise.song().transport:start_at(renoise.SongPos(current_sequence, current_line))     
         
       end         
              
      
       
      
      
    end 
    
    ---if (key.name == "capital") then 
     --- if renoise.song().transport.playing == true then
       
        ---local current_sequence = renoise.song().transport.edit_pos.sequence
       --- local current_line = renoise.song().transport.edit_pos.line
        
      ---  for instrument = 1, #renoise.song().instruments do 
          
         -- for phrase = 1, #renoise.song():instrument(instrument).phrases do
          
          --  if is_pushed[tostring(instrument)..tostring(phrase)] == true then
           
             -- local a = renoise.song():pattern(current_sequence):track(instrument):line(current_line+1) 
       
             -- a:note_column(1).note_value = 48
       
            --- a:effect_column(1).number_string = "0Z"    
       
            ---  a:effect_column(1).amount_value = phrase
              
           --- end  
            
         -- end
          
       --- end
        
     -- end
      
   --- end        
        
                   
          
      
  end
  

  
  local Button_to_move_across_phrases_Column = vb:column{
    Move_Up_Through_Phrases_Button,
    Page_among_phrases_text,
    Move_Down_Through_Phrases_Button
  }        
  
      
            
          
    
       
--- Create the phrases column, the one that goes beyond the Global_column

  local master_superior_column_with_name_and_stop = vb:row{
    height = 36 + 58,
    style = "group",
    
    vb:text{ 
      text = "Master"
    }, 
    
    vb:button{
      text = "S",
      pressed = function()
        
        for InstrumentIndex = 1, #renoise.song().instruments do
          for phrase = 1, #renoise.song().instruments[InstrumentIndex].phrases do
            if is_pushed[tostring(InstrumentIndex)..tostring(phrase)] == true then
              write_phrase_into_pattern(InstrumentIndex, phrase)
            end
          end
        end      
      
      
      end
    }
    
  }      

  local Phrases_column = vb:column{
    id = "Phrases_column",
    
    vb:horizontal_aligner{mode = "right", Button_to_move_across_tracks_Row},
    vb:space{ height = 10},
    vb:row{
      spacing = 5, 
      vb:column{
        vb:row{All_Superior_Tracks_Row, id = "height of superior tracks"},
        vb:space{height = 2},
        vb:row{spacing = 5, All_Tracks_Row},
      }, 
      
      vb:space{height = 50, width = 24},
      
      vb:column{master_superior_column_with_name_and_stop, MasterColumn}
    },   
    vb:row{Show_Or_Hide_Options_Phrases_button},
    vb:horizontal_aligner{mode = "right", Button_to_move_across_phrases_Column}
      
      
  }         
  
 
 -- Show the Custom dialog GUI
 
 renoise.app():show_custom_dialog(
    "Live phrase", 
    vb:column { id = "GUI",
      Global_Column, 
      Phrases_column,
      
      
    },
    key_handler
    
    
  )
  
   --dofile("observables.lua")
   
  local function delete_pattern_when_playing_stops()
  
    if renoise.song().transport.playing == false then
      if vb.views["my_text"].text == "Practice" then
        for i = 1, #renoise.song().patterns do
          renoise.song():pattern(i):clear()
        end 
      end
    end  
  
  end 
  
  --if renoise.song().transport.playing_observable:has_notifier(delete_pattern_when_playing_stops) == false then
    --renoise.song().transport.playing_observable:add_notifier(delete_pattern_when_playing_stops)
  --end    
   
  --renoise.song().transport.playing_observable:add_notifier(function() ---this is only for the free trial:
  --if renoise.song().transport.playing == false then
    --if vb.views["my_text"].text == "Practice" then
      --for i = 1, #renoise.song().patterns do
       -- renoise.song():pattern(i):clear()
     -- end 
    --end
 -- end  

--end)

   
   
      --------------------------------------------------------------------------------------------------------------s
local function instrument_()
  if add_track_is_pushed == true then
    add_track_is_pushed = false
    
  elseif delete_track_is_pushed == true then
    delete_track_is_pushed = false    
    
  elseif #renoise.song().instruments > current_number_of_instruments and add_track_is_pushed == false then
    --renoise.song():delete_instrument_at(#renoise.song().instruments)
            current_number_of_instruments = #renoise.song().instruments
        
        
        
        local this_instrument = #renoise.song().instruments ---store the last instrument added into this variable, so the value gets fixed.
        
        while #renoise.song().tracks-2 < #renoise.song().instruments do 
          renoise.song():insert_track_at(#renoise.song().tracks-2+1)
        end 
        
        
        if vb.views["Superior Column-"..tostring(this_instrument)] == nil then
        ---if track does not exist then create the track...
        
        Superior_Column_dictionary["Superior Column-"..tostring(this_instrument)] = vb:column{
          width = 110,
          style = "group",
          id = "Superior Column-"..tostring(this_instrument),
          
          create_rotary_column(this_instrument),
      
          vb:row{
--- + button - this is where the creation of the + button for the phrase beginns, its a long program...    
            vb:button{            
              text = "+",
              tooltip = "Add a phrase on this track",
              visible = true,
              notifier = function()
              
              

                local Biggest_Track_phrases_before = BiggestTrackPhrases()---check the current number of phrases for the biggest track.
                renoise.song().instruments[this_instrument]:insert_phrase_at(#renoise.song():instrument(this_instrument).phrases+1)---add the phrase.
                local Biggest_Track_phrases_after = BiggestTrackPhrases()---check if the biggest track changed.
        
                local phrase = #renoise.song():instrument(this_instrument).phrases
                
                renoise.song().instruments[this_instrument].phrases[phrase]:clear() ---THIS IS to get rid of the c4 note.
        
                if vb.views["Phrase Column-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)] == nil then
                ---if phrase does not exist then create the phrase...
                  vb:column{
                    width = 110,
                    style = "panel",
                    id = "Phrase Column-"..tostring(this_instrument)..tostring(phrase),
          
    
                    vb:column{    
                      vb:row{         
                        vb:button {
                          id = "Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                          color = {0x60, 0x60, 0x60},
                          text = "¤",
                          notifier = function()
                          end
                        },      
                        vb:text{
                          text = "Hidden",
                          id = "Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                          visible = false
                        },
                        vb:text{
                          text = "Phrase-"..tostring(#renoise.song():instrument(this_instrument).phrases+1),
                          id = "Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)
                        },
                        vb:button{
                          text = "Play",
                          id = "play_button_"..tostring(this_instrument)..tostring(phrase),
                          tooltip = "Play this phrase",
                          pressed = function()
                          
                            write_phrase_into_pattern(this_instrument, phrase)
                          
                          end
                        }        
                      }      
                    },
          
                    vb:column{
                      id = "Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                      visible = false,    
                      vb:row{      
                        vb:button{
                          text = "C",
                          tooltip = "Copy this phrase's content",
                          notifier = function()
                            last_phrase_copied = {this_instrument, phrase}
                          end
                        },
                        
                        vb:button{                            
                          text = "↑",
                          tooltip = "Transpose this phrase one semitone up",
                          notifier = function()
                          
                            transpose_phrase(1, this_instrument, phrase)
                            
                          end
                        },
                          
                        vb:button{             
                          text = "↓",
                          tooltip = "Transpose this phrase one semitone down",
                          notifier = function()
                          
                            transpose_phrase(-1, this_instrument, phrase)
                            
                          end
                        },    
                        
                        
                        
                        vb:button{
                          color = {0xff, 0xff, 0x00},
                          text = "L",
                          id = "legato_mode"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases),
                          tooltip = "Activate the legato mode for this phrase",
                          notifier = function()
                          
                            local legato = "legato_mode"..tostring(this_instrument)..tostring(phrase)
                              
                            if legato_is_pushed[legato] == false then 
                              vb.views[legato].color = {0xff, 0xff, 0x00} 
                              legato_is_pushed[legato] = true
                              
                            elseif legato_is_pushed[legato] == nil or legato_is_pushed[legato] == true then 
                              vb.views[legato].color = {0, 0, 0}  
                              legato_is_pushed[legato] = false
                              
                            end  
                              
                          end
                        },
                        
                        vb:button{
                          text = "X",
                          tooltip = "Duplicate the content of this phrase",
                          notifier = function()
                          
                            local a = renoise.song():instrument(this_instrument):phrase(phrase)
                            local sum = a.number_of_lines
                            
                            a.number_of_lines = sum * 2
                            
                            for i = 1, sum do
                            
                              for column = 1, #a:line(1).note_columns do
                              
                                a:line(i + sum):note_column(column).note_value = a:line(i):note_column(column).note_value
                                a:line(i + sum):note_column(column).volume_value = a:line(i):note_column(column).volume_value
                                a:line(i + sum):note_column(column).panning_value = a:line(i):note_column(column).panning_value
                                a:line(i + sum):note_column(column).delay_value = a:line(i):note_column(column).delay_value
                                a:line(i + sum):note_column(column).effect_number_value = a:line(i):note_column(column).effect_number_value
                                a:line(i + sum):note_column(column).effect_amount_value = a:line(i):note_column(column).effect_amount_value  
                                                                                            
                              end  
                              
                              for column = 1, #a:line(1).effect_columns do
                                
                                a:line(i + sum):effect_column(column).number_value = a:line(i):effect_column(column).number_value
                                a:line(i + sum):effect_column(column).amount_value = a:line(i):effect_column(column).amount_value   
                                
                              end                              
                              
                            end  
                          
                          
                          
                          end
                          
                        }      
                      },      
                      vb:row{      
                        vb:button{
                          text = "P",
                          tooltip = "Paste the last content copied into this phrase",
                          notifier = function()
                      
                            renoise.song():instrument(this_instrument):phrase(phrase):copy_from(renoise.song():instrument(last_phrase_copied[1]):phrase(last_phrase_copied[2]))
                          end
                        },
                        vb:button{
                          text = "D",
                          tooltip = "Delete this phrase's content",
                          notifier = function()
                            renoise.song().instruments[this_instrument].phrases[phrase]:clear()
                          end
                        },
                        vb:button{
                          text = "G",
                          tooltip = "Go this Phrase editor",
                          notifier = function()
                            renoise.song().selected_instrument_index = this_instrument
                            renoise.song().selected_phrase_index = phrase
                            renoise.app().window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_PHRASE_EDITOR                  
                    
                          end
                        }           
                      }      
                    }
      
                } 
        
                if #renoise.song():instrument(this_instrument).phrases < 10 then vb.views["Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Phrase-00"..tostring(#renoise.song():instrument(this_instrument).phrases)
                elseif #renoise.song():instrument(this_instrument).phrases < 100 then vb.views["Number_Of_Phrase"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Phrase-0"..tostring(#renoise.song():instrument(this_instrument).phrases)
                end       
                end
        
        
                if vb.views["S/H VAR"].text == "Shown" then
                         
                  vb.views["Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].visible = true 
              
                  vb.views["Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Shown"
                
                  vb.views["Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].color = {0x90, 0x70, 0x70} 
                          
                end     
        
                if vb.views["S/H VAR"].text == "Hidden" then    
          
                  vb.views["Options Column of Phrase-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].visible = false
          
                  vb.views["Show_Options_Column_text"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Hidden"
          
                  vb.views["Show_Options_Column_button"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases)].color = {0x60, 0x60, 0x60}
          
                end  
                
                renoise.song():instrument(this_instrument):phrase(phrase).number_of_lines = tonumber(vb.views["LPP_Button"].text)  
                renoise.song():instrument(this_instrument):phrase(phrase).lpb = tonumber(vb.views["LPB_Button"].text)     
              
        
                ---Now, there are two situation when we need to update the GUI. One is when we are in the last page of a track and the phrases do not make for the 10 phrase limit. The other case is when we are after the last page of a track that filled all the 10 phrases limit.
        
                local IsRouteB = nil
                local IsRouteA = nil
                local constant = Number_of_phrases_per_page - 1
                local Number_Of_Pages_For_This_Track = #renoise.song():instrument(this_instrument).phrases - constant
                if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
        
                local array = {} 
                for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                table.insert(array, column)
       
                end
        
                local IsColumn --- we need to write this code in order to find the number of column (1 to 10) where we are going to place our phrase.
                for i = 1, #array do
                  if this_instrument == array[i] then 
                    IsColumn = i
                    break
                  end
                end    
        
                for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(this_instrument)-1 do
          
                  ---this is route A:
                  if tonumber(vb.views["Page_among_phrases_text"].text) == page and Limit_values_For_Phrases(this_instrument)[page][2] <= Number_of_phrases_per_page + page - 1 then
            
                    vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(tostring(#renoise.song():instrument(this_instrument).phrases))]) 
                    IsRouteA = true  
                    print("route A")                
                    break
                  end
                end    
        
                ---this is route B:  
                if tonumber(vb.views["Page_among_phrases_text"].text) == #Limit_values_For_Phrases(this_instrument) then
                    vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["space"..tostring(this_instrument)])
                    vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(tostring(#renoise.song():instrument(this_instrument).phrases))]) 
                    IsRouteA = false 
                    IsRouteB = true
                    print("route B")                   
                end
        
               ---So far we're good. The last thing we need to do is to update the master track.. if needed.
        
                if Biggest_Track_phrases_after - Biggest_Track_phrases_before == 1 then
                  if vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases)] == nil then
                    vb:column{
                      id = "Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases),        
                      vb:button{
                        text = "Play-"..tostring(#renoise.song():instrument(this_instrument).phrases),
                        id = "Play Button from master"..tostring(#renoise.song():instrument(this_instrument).phrases),
                        pressed = function()
                          
                          play_button_for_master(phrase)
                          
                        end  
                          
                      }              
                    }
                  end  
      
                  if #renoise.song():instrument(this_instrument).phrases < 10 then vb.views["Play Button from master"..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Play-00"..tostring(#renoise.song():instrument(this_instrument).phrases)   
                  elseif #renoise.song():instrument(this_instrument).phrases < 100 then vb.views["Play Button from master"..tostring(#renoise.song():instrument(this_instrument).phrases)].text = "Play-0"..tostring(#renoise.song():instrument(this_instrument).phrases)
                  end
                  ---
        
                  if IsRouteA == true then
            
                    vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases)])
          
                  end
          
                  if IsRouteB == true and #renoise.song():instrument(this_instrument).phrases == 1 then
          
                    vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases)])
            
                  end    
          
                end  
              
              end            
            },
--- "-" button            
            vb:button{
              text = "-",
              tooltip = "Delete a phrase on this track",
              visible = true,
              notifier = function()

                if #renoise.song():instrument(this_instrument).phrases > 0 then 
                  local routeA  
                  local numberOfPhrases_avant = #renoise.song():instrument(this_instrument).phrases---check the number of phrases in this track before deleting the last phrase.
                  local Biggest_Track_phrases_before = BiggestTrackPhrases()---check the current number of phrases for the biggest track.
          
                  renoise.song().instruments[this_instrument]:delete_phrase_at(#renoise.song():instrument(this_instrument).phrases)--delete the last phrase.
                  local numberOfPhrases_apres = #renoise.song():instrument(this_instrument).phrases---check the number of phrases in this track after deleting the last phrase.
                  local Biggest_Track_phrases_after = BiggestTrackPhrases()---check if the biggest track changed.
                  local IsSpaceNeeded = nil
          
                       
        
                ---Now, there are two situation when we need to update the GUI. Route A represents the situation where there are zero phrases because we just deleted the first and only phrase and thus we'll need to agregate an space to not collapse the view. Route B is when there are still phrases in the view, even after deleting the last phrase.
        
                  ---local IsRouteB = nil
                  local constant = Number_of_phrases_per_page - 1
                  local Number_Of_Pages_For_This_Track = #renoise.song():instrument(this_instrument).phrases - constant +1
                  if Number_Of_Pages_For_This_Track <= 0 then Number_Of_Pages_For_This_Track = 1 end
          
                  local array2 = {} 
                  for column = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                  table.insert(array2, column)
       
                  end
        
                  local IsColumn --- we need to write this code in order to find the number of column (1 to 10) where we are going to place our phrase.
                  for i = 1, #array2 do
                    if this_instrument == array2[i] then 
                      IsColumn = i
                      break
                    end
                  end              
          
                  ---this is route A
                  if (Limit_values_For_Phrases(this_instrument) == nil and numberOfPhrases_avant-numberOfPhrases_apres == 1) and tonumber(vb.views["Page_among_phrases_text"].text) == 1 then
                    vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(1)]) 
                    if vb.views["space"..tostring(this_instrument)] == nil then            
                      vb:space{width = 110, id = "space"..tostring(this_instrument)} 
                    end 
                    vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["space"..tostring(this_instrument)])
                    routeA = true
                  end  
          
                  ---this is route B:
                  if Limit_values_For_Phrases(this_instrument) ~= nil then
            
                    for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(this_instrument)+1 do
          
                      if tonumber(vb.views["Page_among_phrases_text"].text) == page then
                
                       --- IsRouteB = true
            
            
                        vb.views["column-"..tostring(IsColumn)]:remove_child(vb.views["Phrase Column-"..tostring(this_instrument)..tostring(#renoise.song():instrument(this_instrument).phrases+1)]) 
     
        
                        if Limit_values_For_Phrases(this_instrument)[tonumber(vb.views["Page_among_phrases_text"].text)] == nil  then
          
                          if vb.views["space"..tostring(this_instrument)] == nil then            
                          vb:space{width = 110, id = "space"..tostring(this_instrument)} 
                          end 
        
                          vb.views["column-"..tostring(IsColumn)]:add_child(vb.views["space"..tostring(this_instrument)])
       
                        end  
                
              
                      end  
              
                    end
                  end    
            
                    ---Now lets make some code in case we are at the last page with only one phrase. In that case we'll need to update all the tracks and change the page.
                    if Limit_values_For_Phrases(this_instrument) ~= nil then
             
             
                      if Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 and #Limit_values_For_Phrases(this_instrument)+1 == tonumber(vb.views["Page_among_phrases_text"].text)  then---if we'll need to update the master column and we are also in the last page of the track...
                
              
                        ---print("hi")
                
                        vb.views["Page_among_phrases_text"].text = tostring(tonumber(vb.views["Page_among_phrases_text"].text)-1)
                
                        local array = {}
                        for i = Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][1], Limit_values_For_Tracks()[tonumber(Page_among_tracks_text.text)][2] do 
                        table.insert(array, i)
       
                        end
       
                        for i = 1, #array do
       
                          ---lets remove the content first for each given track.
                          if Limit_values_For_Phrases(array[i]) == nil or tonumber(Page_among_phrases_text.text)+1 > #Limit_values_For_Phrases(array[i]) then
                            if vb.views["space"..tostring(array[i])] ~= nil then   
                              vb.views["column-"..tostring(i)]:remove_child(vb.views["space"..tostring(array[i])])
                            end            
         
                          else
                            for phrase = Limit_values_For_Phrases(array[this_instrument])[tonumber(Page_among_phrases_text.text)+(1)][1], Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)+(1)][2] do                                        
                              vb.views["column-"..tostring(i)]:remove_child(vb.views["Phrase Column-"..tostring(array[i])..tostring(phrase)])
                            end
                     
                          end  
         
                          ---now lets add new content for the new page.
                          if Limit_values_For_Phrases(array[i]) == nil or tonumber(Page_among_phrases_text.text) > #Limit_values_For_Phrases(array[i]) then 
                            if vb.views["space"..tostring(array[i])] == nil then
                              vb:space{width = 110, id = "space"..tostring(array[i])}
                            end  
                      
                            vb.views["column-"..tostring(i)]:add_child(vb.views["space"..tostring(array[i])]) 
                      
         
                          else
                  

                            for phrase = Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)][1], Limit_values_For_Phrases(array[i])[tonumber(Page_among_phrases_text.text)][2] do                                        
                      vb.views["column-"..tostring(i)]:add_child(vb.views["Phrase Column-"..tostring(array[i])..tostring(phrase)])
                            end
                     
                     
                          end   
         
         
           
         
         
                        end
       
                        if limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)] ~= nil then
                          for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)+(1)][2] do
                            vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(master)])         
                          end
                        end  
       
                        if limit_values_for_master()[tonumber(Page_among_phrases_text.text)] ~= nil then  
                          for master = limit_values_for_master()[tonumber(Page_among_phrases_text.text)][1], limit_values_for_master()[tonumber(Page_among_phrases_text.text)][2] do
                            if vb.views["Master Column dictionary"..tostring(master)] == nil then
                              MasterColumns_dictionary["Master Column dictionary"..tostring(master)] = vb:column{
                                id = "Master Column dictionary"..tostring(master),
        
                                vb:button{
                                text = "Play-"..tostring(master),
                                id = "Play Button from master"..tostring(master)
                                }             
                              }
                            end    
                            vb.views["MasterColumn"]:add_child(vb.views["Master Column dictionary"..tostring(master)])         
                          end
                        end 
                
                        vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases+1)]) 
                 
         
             
                     else
             
                       for page = Number_Of_Pages_For_This_Track, #Limit_values_For_Phrases(this_instrument)+1 do
          
                         if tonumber(vb.views["Page_among_phrases_text"].text) == page and Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 then 
                           vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases+1)])       
                 
                         end    
                       end
                     end 
             
                   end 
    
      
            
                    if routeA == true then ---if we need to update the master column and we just deleted the first and only phrase of the track.
                      if Biggest_Track_phrases_before - Biggest_Track_phrases_after == 1 then
                        vb.views["MasterColumn"]:remove_child(vb.views["Master Column dictionary"..tostring(#renoise.song():instrument(this_instrument).phrases+1)])
                      end  
                    end
              
              
                  
             
           
                end
                
                vb.views["play_button_"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                vb.views["Phrase Column-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                vb.views["Show_Options_Column_button"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                vb.views["Show_Options_Column_text"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                vb.views["Number_Of_Phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                vb.views["legato_mode"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                vb.views["quantization_setup_phrase"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil         
                vb.views["Options Column of Phrase-"..tostring(InstrumentIndex)..tostring(#renoise.song():instrument(InstrumentIndex).phrases+1)] = nil
                
              end
             
            }    
              
       
      
      
            },
    
          vb:row{
  
            vb:text{
              text = "Track-"..tostring(this_instrument),
              id = "Track_Number_text"..tostring(this_instrument) 
            },
            
            vb:button{
              text = "S",
              tooltip = "Stop this track",
              notifier = function()
                
              end
            },
            
            vb:space{
              width = 110-70
            }              
      
          }
    
        }
        
        if  this_instrument < 10 then vb.views["Track_Number_text"..tostring(this_instrument)].text = "Track-00"..tostring(this_instrument)
        elseif this_instrument < 100 then vb.views["Track_Number_text"..tostring(this_instrument)].text = "Track-0"..tostring(this_instrument)
        end
        
      end --- este es el "end" del condicional "if" en caso de que la columna no exista. 
      
      while Page_among_tracks_text.text == "1" do--- si los tracks en la columna no están completos, es decir, no llegan a 10, entonces agrega uno a la columna.
        if #renoise.song().instruments <= Number_of_phrases_per_page then
          vb.views["All_Superior_Tracks_Row"]:add_child(vb.views["Superior Column-"..tostring(this_instrument)])
          if vb.views["space"..tostring(this_instrument)] == nil then            
            vb:space{width = 110, id = "space"..tostring(this_instrument)}
          end   
          ---vb.views["column-"..tostring(this_instrument)]:add_child(vb.views["space"..tostring(this_instrument)])
        end
        print(vb.views["Superior Column-"..tostring(1)].width)
        break
      end  
      
      
        
  end
end  
  
if renoise.song().instruments_observable:has_notifier(instrument_) == false then 
  renoise.song().instruments_observable:add_notifier(instrument_)
end    


end

 


   


